import matplotlib
matplotlib.use('Agg')
import matplotlib.pyplot as plt
import pickle
import pandas as pd
import numpy as np

def save_obj( data, name ):
    with open(name,'wb') as f:
        pickle.dump(data, f, protocol=pickle.HIGHEST_PROTOCOL);


def load_obj( name ):
    with open(name,'rb') as f:
        return pickle.load(f);

###############################################################
#buffer validation 
###############################################################
#first gi curation, 28319113
'''sample = pd.read_pickle('update_data/sample_original.pkl')
slope = pd.read_pickle('update_data/c_slope.pkl')
cor = pd.read_pickle('update_data/c.pkl')
hit = pd.read_csv('update_data/gi_1.csv', sep = ',')
for i in range(0,len(hit.index)):
    if (hit.loc[i,'geneA'] in cor.index) and (hit.loc[i,'geneB'] in cor.index):
        if (hit.loc[i,'geneB'] in cor.columns):
            cor1 = cor.loc[hit.loc[i,'geneA'],hit.loc[i,'geneB']]
        else:
            cor1 = -2
        if (hit.loc[i,'geneA'] in cor.columns):
            cor2 = cor.loc[hit.loc[i,'geneB'],hit.loc[i,'geneA']]
        else:
            cor2 = -2
        if (cor1 == -2) & (cor2 == -2):
            continue
        if cor1 > cor2:
            hit.loc[i,'g1'] = hit.loc[i,'geneA']
            hit.loc[i,'g2'] = hit.loc[i,'geneB']
            hit.loc[i,'c'] = cor1
        else:
            hit.loc[i,'g1'] = hit.loc[i,'geneB']
            hit.loc[i,'g2'] = hit.loc[i,'geneA']
            hit.loc[i,'c'] = cor2
        hit.loc[i,'slope'] = slope.loc[hit.loc[i,'g1'],hit.loc[i,'g2']]
hit.to_pickle('update_data/gi_1.pkl')
#'''

'''dep = pd.read_pickle('update_data/ceres.pkl')
exp = pd.read_pickle('update_data/exp_ceres.pkl')
exp = exp.dropna( how = 'all')
exp_all = pd.read_pickle('update_data/exp_original.pkl')
sample = pd.read_pickle('update_data/sample_original.pkl')
hit = pd.read_pickle('update_data/gi_1.pkl')
hit = hit.dropna(how = 'all')
hit = hit.rename({'HeLa_Z':'HELA','A549_Z':'A549','293T_Z':'HEKTE'}, axis = 1)
print(hit)
concat = []
name = ['HELA','A549','HEKTE']
assign = hit.dropna(how = 'any').index
for i in assign:
    hit.loc[i,'g1_mean'] = exp.loc[:,hit.loc[i,'g1']].mean()
    hit.loc[i,'g1_std'] = exp.loc[:,hit.loc[i,'g1']].std()
    hit.loc[i,'g1_1'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.01)
    hit.loc[i,'g1_10'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.1)
    hit.loc[i,'g1_15'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.15)
    hit.loc[i,'g1_20'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.2)
    hit.loc[i,'g1_21'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.21)
    hit.loc[i,'g1_22'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.22)
    hit.loc[i,'g1_23'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.23)
    hit.loc[i,'g1_24'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.24)
    hit.loc[i,'g1_25'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.25)
    hit.loc[i,'g1_26'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.26)
    hit.loc[i,'g1_27'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.27)
    hit.loc[i,'g1_28'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.28)
    hit.loc[i,'g1_29'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.29)
    hit.loc[i,'g1_30'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.3)
    hit.loc[i,'g1_33'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.33)
    hit.loc[i,'g2_mean'] = dep.loc[:,hit.loc[i,'g2']].mean()
    hit.loc[i,'g2_std'] = dep.loc[:,hit.loc[i,'g2']].std()
concat = [];
for i in name:
    tmp = hit.drop(columns = name)
    tmp.loc[:,'gi'] = hit.loc[:,i]
    tmp.loc[:,'cell'] = i;
    idx = sample.index[sample.loc[:,'stripped_cell_line_name'] == i]
    if len(idx) == 1:
        if idx[0] in dep.index:
            tmp.loc[:,'ach'] = idx[0]
            tmp.loc[:,'g1_ach'] = idx[0]
            tmp.loc[:,'g2_ach'] = idx[0]
        else:
            print(idx, 'not in depmap')
    else:
        print(idx, 'not in CCLE or > 1')
    concat.append(tmp)
hit = pd.concat(concat)
name = [i for i in range(0,len(hit.index))]
hit.index = name
assign = hit.dropna(how = 'any').index
for i in assign:
    hit.loc[i,'g1_exp'] = exp_all.loc[ hit.loc[i,'g1_ach'], hit.loc[i,'g1'] ]
    hit.loc[i,'g2_ds'] = dep.loc[ hit.loc[i,'g2_ach'], hit.loc[i,'g2'] ]
print(hit)
hit.to_pickle('update_data/gi_1_curated.pkl')
#'''

#concatenation
'''hit = pd.read_pickle('update_data/gi_1_curated.pkl')
hit.loc[:,'study'] = 1
hit = hit.dropna(how='any')
hit = hit.loc[hit.loc[:,'g1'] != hit.loc[:,'g2'],:]
hit = hit.drop(columns =['geneA', 'geneB']) 
print(hit)
hit.to_pickle('update_data/gi_1_concat.pkl')
#'''

#second gi curation, 27684187
'''cor = pd.read_pickle('update_data/c.pkl')
hit = pd.read_csv('update_data/gi_2.csv', sep = ',')
slope = pd.read_pickle('update_data/c_slope.pkl')
#print(hit)
for i in range(0,len(hit.index)):
    if (hit.loc[i,'Gene_1'] in cor.index) and (hit.loc[i,'Gene_2'] in cor.index):
        if (hit.loc[i,'Gene_2'] in cor.columns):
            cor1 = cor.loc[hit.loc[i,'Gene_1'],hit.loc[i,'Gene_2']]
        else:
            cor1 = -2
        if (hit.loc[i,'Gene_1'] in cor.columns):
            cor2 = cor.loc[hit.loc[i,'Gene_2'],hit.loc[i,'Gene_1']]
        else:
            cor2 = -2
        if (cor1 == -2) & (cor2 == -2):
            continue
        if cor1 > cor2:
            hit.loc[i,'g1'] = hit.loc[i,'Gene_1']
            hit.loc[i,'g2'] = hit.loc[i,'Gene_2']
            hit.loc[i,'c'] = cor1
        else:
            hit.loc[i,'g1'] = hit.loc[i,'Gene_2']
            hit.loc[i,'g2'] = hit.loc[i,'Gene_1']
            hit.loc[i,'c'] = cor2
        hit.loc[i,'slope'] = slope.loc[hit.loc[i,'g1'],hit.loc[i,'g2']]
hit.to_pickle('update_data/gi_2.pkl')
#'''

'''dep = pd.read_pickle('update_data/ceres.pkl')
exp = pd.read_pickle('update_data/exp_ceres.pkl')
exp_all = pd.read_pickle('update_data/exp_original.pkl')
hit = pd.read_pickle('update_data/gi_2.pkl')
sample = pd.read_pickle('update_data/sample_original.pkl')
print(hit)
concat = []
name = ['DLD1','HCT116','HT29','RKO']
assign = hit.dropna(how = 'any').index
for i in assign:
    hit.loc[i,'g1_mean'] = exp.loc[:,hit.loc[i,'g1']].mean()
    hit.loc[i,'g1_std'] = exp.loc[:,hit.loc[i,'g1']].std()
    hit.loc[i,'g2_mean'] = dep.loc[:,hit.loc[i,'g2']].mean()
    hit.loc[i,'g2_std'] = dep.loc[:,hit.loc[i,'g2']].std()
    hit.loc[i,'g1_1'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.01)
    hit.loc[i,'g1_10'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.1)
    hit.loc[i,'g1_15'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.15)
    hit.loc[i,'g1_20'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.2)
    hit.loc[i,'g1_21'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.21)
    hit.loc[i,'g1_22'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.22)
    hit.loc[i,'g1_23'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.23)
    hit.loc[i,'g1_24'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.24)
    hit.loc[i,'g1_25'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.25)
    hit.loc[i,'g1_26'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.26)
    hit.loc[i,'g1_27'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.27)
    hit.loc[i,'g1_28'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.28)
    hit.loc[i,'g1_29'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.29)
    hit.loc[i,'g1_30'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.3)
    hit.loc[i,'g1_33'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.33)
for i in name:
    tmp = hit.drop(columns = name)
    tmp.loc[:,'gi'] = hit.loc[:,i]
    tmp.loc[:,'cell'] = i;
    idx = sample.index[sample.loc[:,'stripped_cell_line_name'] == i]
    if len(idx) == 1:
        if idx[0] in dep.index:
            tmp.loc[:,'ach'] = idx[0]
            tmp.loc[:,'g1_ach'] = idx[0]
            tmp.loc[:,'g2_ach'] = idx[0]
    concat.append(tmp)
hit = pd.concat(concat)
name = [i for i in range(0,len(hit.index))]
hit.index = name
print(hit)
assign = hit.dropna(how = 'any').index
for i in assign:
    hit.loc[i,'g1_exp'] = exp.loc[ hit.loc[i,'g1_ach'], hit.loc[i,'g1'] ]
    hit.loc[i,'g2_ds'] = dep.loc[ hit.loc[i,'g2_ach'], hit.loc[i,'g2'] ]
hit.to_pickle('update_data/gi_2_curated.pkl')
#'''

#concatenation
'''hit = pd.read_pickle('update_data/gi_2_curated.pkl')
#hit.loc[:,'gi'] = (hit.loc[:,'gi'] - hit.loc[:,'gi'].mean()) / hit.loc[:,'gi'].std()
hit.loc[:,'study'] = 2
hit = hit.dropna(how='any')
hit = hit.loc[hit.loc[:,'g1'] != hit.loc[:,'g2'],:]
hit = hit.drop(columns =['Gene_1', 'Gene_2']) 
hit.to_pickle('update_data/gi_2_concat.pkl')
#'''

#curation data 3
'''hit = pd.read_csv('update_data/gi_3.txt', sep = '\t')
hit.loc[:,'group'] = hit.loc[:,'U6 gene'] +'_'+hit.loc[:,'H1 gene'] +'_'+hit.loc[:,'Cell Line']
hit = hit.loc[:,['group','Measured - Expected']]
hit.to_pickle('update_data/gi_3_tmp.pkl')
hit = hit.groupby(['group']).mean()
hit.to_pickle('update_data/gi_3_tmp_2.pkl')
#'''

'''hit = pd.read_pickle('update_data/gi_3_tmp_2.pkl')
hit.loc[:,'group'] = hit.index
hit.columns = ['gi','group']
s = hit.loc[:,'group'].str.split('_').values.tolist()
s = np.array(s)
hit.loc[:,'Gene_1'] = s[:,0]
hit.loc[:,'Gene_2'] = s[:,1]
hit.loc[:,'cell'] = s[:,2]
hit.to_pickle('update_data/gi_3_tmp_3.pkl')
#'''

'''hit = pd.read_pickle('update_data/gi_3_tmp_3.pkl')
hit.loc[:,'cell'] = hit.loc[:,'cell'].str.upper()
cor = pd.read_pickle('update_data/c.pkl')
slope = pd.read_pickle('update_data/c_slope.pkl')
for i in hit.index:
    if (hit.loc[i,'Gene_1'] in cor.index) and (hit.loc[i,'Gene_2'] in cor.index):
        if (hit.loc[i,'Gene_2'] in cor.columns):
            cor1 = cor.loc[hit.loc[i,'Gene_1'],hit.loc[i,'Gene_2']]
        else:
            cor1 = -2
        if (hit.loc[i,'Gene_1'] in cor.columns):
            cor2 = cor.loc[hit.loc[i,'Gene_2'],hit.loc[i,'Gene_1']]
        else:
            cor2 = -2
        if (cor1 == -2) & (cor2 == -2):
            continue
        if cor1 > cor2:
            hit.loc[i,'g1'] = hit.loc[i,'Gene_1']
            hit.loc[i,'g2'] = hit.loc[i,'Gene_2']
            hit.loc[i,'c'] = cor1
        else:
            hit.loc[i,'g1'] = hit.loc[i,'Gene_2']
            hit.loc[i,'g2'] = hit.loc[i,'Gene_1']
            hit.loc[i,'c'] = cor2
        hit.loc[i,'slope'] = slope.loc[hit.loc[i,'g1'],hit.loc[i,'g2']]
hit.to_pickle('update_data/gi_3_tmp_4.pkl')
#'''

'''dep = pd.read_pickle('update_data/ceres.pkl')
exp = pd.read_pickle('update_data/exp_ceres.pkl')
exp_all = pd.read_pickle('update_data/exp_original.pkl')
hit = pd.read_pickle('update_data/gi_3_tmp_4.pkl')
sample = pd.read_pickle('update_data/sample_original.pkl')
print(hit)
concat = []
name = pd.unique(hit.loc[:,'cell']).tolist()
print(name)
assign = hit.dropna(how = 'any').index
for i in assign:
    hit.loc[i,'g1_mean'] = exp.loc[:,hit.loc[i,'g1']].mean()
    hit.loc[i,'g1_std'] = exp.loc[:,hit.loc[i,'g1']].std()
    hit.loc[i,'g2_mean'] = dep.loc[:,hit.loc[i,'g2']].mean()
    hit.loc[i,'g2_std'] = dep.loc[:,hit.loc[i,'g2']].std()
    hit.loc[i,'g1_1'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.01)
    hit.loc[i,'g1_10'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.1)
    hit.loc[i,'g1_15'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.15)
    hit.loc[i,'g1_20'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.2)
    hit.loc[i,'g1_21'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.21)
    hit.loc[i,'g1_22'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.22)
    hit.loc[i,'g1_23'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.23)
    hit.loc[i,'g1_24'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.24)
    hit.loc[i,'g1_25'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.25)
    hit.loc[i,'g1_26'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.26)
    hit.loc[i,'g1_27'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.27)
    hit.loc[i,'g1_28'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.28)
    hit.loc[i,'g1_29'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.29)
    hit.loc[i,'g1_30'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.3)
    hit.loc[i,'g1_33'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.33)
for i in name:
    tmp = hit.loc[ hit.loc[:,'cell'] == i,:]
    idx = sample.index[sample.loc[:,'stripped_cell_line_name'] == i]
    if len(idx) == 1:
        if idx[0] in dep.index:
            tmp.loc[:,'ach'] = idx[0]
            tmp.loc[:,'g1_ach'] = idx[0]
            tmp.loc[:,'g2_ach'] = idx[0]
    concat.append(tmp)
hit = pd.concat(concat)
name = [i for i in range(0,len(hit.index))]
hit.index = name
print(hit)
assign = hit.dropna(how = 'any').index
for i in assign:
    hit.loc[i,'g1_exp'] = exp.loc[ hit.loc[i,'g1_ach'], hit.loc[i,'g1'] ]
    hit.loc[i,'g2_ds'] = dep.loc[ hit.loc[i,'g2_ach'], hit.loc[i,'g2'] ]
hit.to_pickle('update_data/gi_3_curated.pkl')
#'''

#concatenation
'''hit = pd.read_pickle('update_data/gi_3_curated.pkl')
#hit.loc[:,'gi'] = (hit.loc[:,'gi'] - hit.loc[:,'gi'].mean()) / hit.loc[:,'gi'].std()
hit.loc[:,'study'] = 3
hit = hit.dropna(how='any')
hit = hit.loc[hit.loc[:,'g1'] != hit.loc[:,'g2'],:]
hit = hit.drop(columns =['Gene_1', 'Gene_2', 'group']) 
print(hit)
hit.to_pickle('update_data/gi_3_concat.pkl')
#'''

#fourth gi curation
'''cor = pd.read_pickle('update_data/c.pkl')
hit = pd.read_csv('update_data/gi_4.csv', sep = ',')
slope = pd.read_pickle('update_data/c_slope.pkl')
#print(hit)
for i in range(0,len(hit.index)):
    if (hit.loc[i,'geneA'] in cor.index) and (hit.loc[i,'geneB'] in cor.index):
        if (hit.loc[i,'geneB'] in cor.columns):
            cor1 = cor.loc[hit.loc[i,'geneA'],hit.loc[i,'geneB']]
        else:
            cor1 = -2
        if (hit.loc[i,'geneA'] in cor.columns):
            cor2 = cor.loc[hit.loc[i,'geneB'],hit.loc[i,'geneA']]
        else:
            cor2 = -2
        if (cor1 == -2) & (cor2 == -2):
            continue
        if cor1 > cor2:
            hit.loc[i,'g1'] = hit.loc[i,'geneA']
            hit.loc[i,'g2'] = hit.loc[i,'geneB']
            hit.loc[i,'c'] = cor1
        else:
            hit.loc[i,'g1'] = hit.loc[i,'geneB']
            hit.loc[i,'g2'] = hit.loc[i,'geneA']
            hit.loc[i,'c'] = cor2
        hit.loc[i,'slope'] = slope.loc[hit.loc[i,'g1'],hit.loc[i,'g2']]
hit.to_pickle('update_data/gi_4.pkl')
#'''

'''dep = pd.read_pickle('update_data/ceres.pkl')
exp = pd.read_pickle('update_data/exp_ceres.pkl')
exp_all = pd.read_pickle('update_data/exp_original.pkl')
hit = pd.read_pickle('update_data/gi_4.pkl')
sample = pd.read_pickle('update_data/sample_original.pkl')
print(hit)
concat = []
name = ['HELA','A549']
assign = hit.dropna(how = 'any').index
for i in assign:
    hit.loc[i,'g1_mean'] = exp.loc[:,hit.loc[i,'g1']].mean()
    hit.loc[i,'g1_std'] = exp.loc[:,hit.loc[i,'g1']].std()
    hit.loc[i,'g2_mean'] = dep.loc[:,hit.loc[i,'g2']].mean()
    hit.loc[i,'g2_std'] = dep.loc[:,hit.loc[i,'g2']].std()
    hit.loc[i,'g1_1'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.01)
    hit.loc[i,'g1_10'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.1)
    hit.loc[i,'g1_15'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.15)
    hit.loc[i,'g1_20'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.2)
    hit.loc[i,'g1_21'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.21)
    hit.loc[i,'g1_22'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.22)
    hit.loc[i,'g1_23'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.23)
    hit.loc[i,'g1_24'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.24)
    hit.loc[i,'g1_25'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.25)
    hit.loc[i,'g1_26'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.26)
    hit.loc[i,'g1_27'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.27)
    hit.loc[i,'g1_28'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.28)
    hit.loc[i,'g1_29'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.29)
    hit.loc[i,'g1_30'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.3)
    hit.loc[i,'g1_33'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.33)
for i in name:
    tmp = hit.drop(columns = name)
    tmp.loc[:,'gi'] = hit.loc[:,i]
    tmp.loc[:,'cell'] = i;
    idx = sample.index[sample.loc[:,'stripped_cell_line_name'] == i]
    if len(idx) == 1:
        if idx[0] in dep.index:
            tmp.loc[:,'ach'] = idx[0]
            tmp.loc[:,'g1_ach'] = idx[0]
            tmp.loc[:,'g2_ach'] = idx[0]
    concat.append(tmp)
hit = pd.concat(concat)
name = [i for i in range(0,len(hit.index))]
hit.index = name
print(hit)
assign = hit.dropna(how = 'any').index
for i in assign:
    hit.loc[i,'g1_exp'] = exp.loc[ hit.loc[i,'g1_ach'], hit.loc[i,'g1'] ]
    hit.loc[i,'g2_ds'] = dep.loc[ hit.loc[i,'g2_ach'], hit.loc[i,'g2'] ]
hit.to_pickle('update_data/gi_4_curated.pkl')
#'''

#concatenation
'''hit = pd.read_pickle('update_data/gi_4_curated.pkl')
#hit.loc[:,'gi'] = (hit.loc[:,'gi'] - hit.loc[:,'gi'].mean()) / hit.loc[:,'gi'].std()
hit.loc[:,'study'] = 4
hit = hit.dropna(how='any')
hit = hit.loc[hit.loc[:,'g1'] != hit.loc[:,'g2'],:]
hit = hit.drop(columns =['geneA', 'geneB']) 
hit.to_pickle('update_data/gi_4_concat.pkl')
#'''

#sg validation
'''hit = [];
for i in [1,2,3,4]:
    tmp = pd.read_pickle('update_data/gi_'+str(i)+'_concat.pkl')
    hit.append(tmp)
hit = pd.concat(hit)
print(len(hit))
name = [i for i in range(0,len(hit.index))]
hit.index = name
print(hit)
hit = hit.loc[hit.loc[:,'c']>0.1,:]
hit.to_pickle('update_data/gi_experiment.pkl')
#'''

#add other cut-off
'''hit = pd.read_pickle('update_data/gi_experiment.pkl')
exp = pd.read_pickle('update_data/exp_ceres.pkl')
for i in hit.index:
    print(i)
    hit.loc[i,'g1_35'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.35)
    hit.loc[i,'g1_40'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.40)
    hit.loc[i,'g1_45'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.45)
    hit.loc[i,'g1_50'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.50)
    hit.loc[i,'g1_19'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.19)
    hit.loc[i,'g1_18'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.18)
    hit.loc[i,'g1_17'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.17)
    hit.loc[i,'g1_16'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.16)
    hit.loc[i,'g1_10'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.10)
    hit.loc[i,'g1_5'] = exp.loc[:,hit.loc[i,'g1']].quantile(0.05)
hit.to_pickle('update_data/gi_experiment_add.pkl')
#'''

#analysis
'''import scipy.stats as stat
from sklearn.metrics import roc_curve, auc
hit = pd.read_pickle('update_data/gi_experiment_add.pkl')
print(hit.columns)
out = []
for j in ['1','5','10','15','20','25','30','35','40','45','50']:
    print(j)
    hit.loc[:,'sl'] = (hit.loc[:,'g1_exp']-hit.loc[:,'g1_'+j])/hit.loc[:,'slope']
    hit.loc[:,'gene_pair'] = hit.loc[:,'g2'] + '_' + hit.loc[:,'g1']
    result = pd.DataFrame(np.linspace(0.1,0.3,num = 21), columns = ['cut'])
    for i in result.index:
        tmp = hit.loc[ hit.loc[:,'c'] > result.loc[i,'cut'], :]
        result.loc[i,'r'], result.loc[i,'p']= stat.pearsonr(tmp.loc[:,'gi'],tmp.loc[:,'sl'])
        result.loc[i,'num'] = len(tmp.index)
    print(result)
    result.loc[:,'perc'] = j
    print(stat.pearsonr(result.loc[:,'r'], result.loc[:,'cut']))
    out.append(result)
out = pd.concat(out, axis = 0)
print(out)
out.to_csv('working_data/com_sg_perc.csv')
result.to_csv('working_data/com_sg_cut.csv')
hit = hit.loc[ hit.loc[:,'c'] > 0.27, :]
print(hit)
hit.to_csv('working_data/com_sg_validation.csv')
#'''

#mann whitney U
'''from sklearn.metrics import roc_curve, auc
import matplotlib.backends.backend_pdf
from matplotlib import cm
import scipy.stats as stat_2

pdf = matplotlib.backends.backend_pdf.PdfPages('5_4_roc.pdf')
hit = pd.read_pickle('update_data/gi_experiment_add.pkl')
hit.loc[:,'sl'] = -(hit.loc[:,'g1_exp']-hit.loc[:,'g1_25'])/hit.loc[:,'slope']

import warnings
warnings.filterwarnings('ignore')
ran = list(np.linspace(0.1,0.25,num = 6))
cm_subsection = np.linspace(0,1,len(ran)+1)
colors = [cm.hot(i) for i in cm_subsection]
result_p = pd.DataFrame( np.nan, index = ['no'] + ran, columns = ['roc','p'])
fig = plt.figure()
ax = fig.add_subplot(111)
cnt = 0
y_t = hit.loc[:,'gi']
y_t.loc[y_t>0] = 1
y_t.loc[y_t<0] = 0
x_t = hit.loc[:,'sl']
fpr, tpr, _ = roc_curve(y_t, x_t)
roc_aur = auc(fpr, tpr)
result_p.loc['no','roc'] = roc_aur
_, result_p.loc['no','p'] = stat_2.mannwhitneyu( hit.loc[y_t == 1,'sl'], hit.loc[y_t == 0,'sl'])
plt.text( 0.9, 0.9, 'no: %.2f' %roc_aur, transform = ax.transAxes)
if True:
    plt.plot( fpr, tpr, color = colors[cnt], lw = 2)
    cnt += 1
for j in ran:
    hit = hit.loc[hit.loc[:,'c']>j,:]
    y_t = hit.loc[:,'gi']
    y_t.loc[y_t>0] = 1
    y_t.loc[y_t<0] = 0
    x_t = hit.loc[:,'sl']
    fpr, tpr, _ = roc_curve(y_t, x_t)
    roc_aur = auc(fpr, tpr)
    plt.text( 0.9, j*3, '%.2f: %.2f' %(j,roc_aur), transform = ax.transAxes)
    _, result_p.loc[j,'p'] = stat_2.mannwhitneyu( hit.loc[y_t == 1,'sl'], hit.loc[y_t == 0,'sl'])
    result_p.loc[j,'roc'] = roc_aur
    if True:
        plt.plot( fpr, tpr, color = colors[cnt], lw = 2)
        cnt += 1
plt.plot( [0,1],[0,1],color = 'navy',lw = 2, linestyle = '--')
plt.xlabel('False Positive Rate')
plt.ylabel('True Positive Rate')
pdf.savefig(fig)
print(result_p)
pdf.close()
#'''

#gene pair table
'''hit = pd.read_pickle('update_data/gi_experiment_add.pkl')
print(len(hit))
print(hit.columns)
#final = hit.drop_duplicates(subset = ['g1','g2'])
#hit = hit.drop_duplicates(subset = ['g1','g2','study'])
hit.loc[:,'sl'] = -(hit.loc[:,'g1_exp']-hit.loc[:,'g1_25'])/hit.loc[:,'slope']
final = hit.copy()
final = final.loc[:,['g2','g1','c','gi','sl','cell','study']]
if False:
    final.loc[:,1] = 'No'
    final.loc[:,2] = 'No'
    final.loc[:,3] = 'No'
    final.loc[:,4] = 'No'
paralog = pd.read_pickle('update_data/paralog_mapping.pkl')
print(paralog)
for i in final.index:
    tmp = hit.loc[(hit.loc[:,'g1'] == final.loc[i,'g1']) &(hit.loc[:,'g2'] == final.loc[i,'g2']),:]
    if paralog.loc[hit.loc[i,'g1'],'family'] == paralog.loc[hit.loc[i,'g2'],'family']:
        final.loc[i,'paralog-pair'] = 1
    else:
        final.loc[i,'paralog-pair'] = 0
    #for j in tmp.index:
    #    final.loc[i,tmp.loc[j,'study']] = 'Yes'
final.rename(columns = {'g1':'g2','g2':'g1'}, inplace = True)
print(final.sort_values(by = 'c',ascending = False))
final.to_csv('table/sg_gene_pair.csv')
print(len(final.index))
print(len(final.loc[final.loc[:,'c']>0.27,:]))
print(len(final.loc[(final.loc[:,'c']>0.27) & (final.loc[:,'paralog-pair'] == 1),:]))
#'''

#sl score mean + 1sd curation for DEPMAP
'''c = pd.read_pickle('update_data/c.pkl')
exp = pd.read_pickle('update_data/exp_ceres.pkl')
slope = pd.read_pickle('update_data/slope.pkl')
x = c>0.25
c = c[x]
s = x.sum().sum()
index = [ i for i in range(s)]
out = []
cnt = 0
for i in c.index:
    tmp = c.loc[i,:].dropna()
    col = [j+'_'+i for j in tmp.index]
    if len(col) > 0:
        exp_tmp = - (exp.loc[:,i] - exp.loc[:,i].quantile(0.25))
        exp_tmp = np.reshape(np.array(exp_tmp.values.tolist()),(1,-1))/np.reshape(np.array(slope.loc[i,:].reindex(tmp.index).values.tolist()),(-1,1))
        result = pd.DataFrame(exp_tmp, index = col, columns = exp.index)
        out.append(result)
out = pd.concat(out)
print(out)
out.to_pickle('update_data/sl_larger_25.pkl')
print('finish')
#'''

#sl mean for different subtype
'''sl = pd.read_pickle('update_data/sl_larger_25.pkl')
sl = sl.mean()
sample = pd.read_pickle('update_data/sample_ceres.pkl')
disease = pd.unique(sample.loc[:,'disease'])
disease = list(disease)
result = pd.DataFrame(np.nan, index = disease, columns = ['sl_mean'])
for i in result.index:
    result.loc[i,'sl_mean'] = sl.loc[sample.loc[sample.loc[:,'disease'] == i,:].index].mean()
print(result.sort_values(by = 'sl_mean'))
result.to_csv('table/sl_mean_tissue.csv')
#'''
