import matplotlib
matplotlib.use('Agg')
import matplotlib.pyplot as plt
import pickle
import pandas as pd
import numpy as np

def save_obj( data, name ):
    with open(name,'wb') as f:
        pickle.dump(data, f, protocol=pickle.HIGHEST_PROTOCOL);


def load_obj( name ):
    with open(name,'rb') as f:
        return pickle.load(f);

###############################################################
#extracting depmap data & c-score
###############################################################
#ceres 19q4
'''f = open("update_data/public_data/CERES_19Q4.csv", "r")

#extract gene name and remove HGNC
gene = f.readline()
gene = np.array(gene.replace('\n','').replace('.','_').split(','));
gene = gene[1:];
entrez = [];
i = 0;
while i <len(gene):
    start = 0;
    start = gene[i].find(' ',0);
    entrez.append(gene[i][start+2:len(gene[i])-1])
    gene[i] = gene[i][0:start];
    i = i + 1;
entrez = pd.DataFrame(entrez,index = gene, columns = ['entrez'])
entrez.to_pickle('update_data/entrez.pkl')
print(entrez)

#extract cell line and values
cell = f.read();
f.close();
cell = cell.split('\n');
cell = cell[0:len(cell)-1];
values = [];
cell_name = [];
for i in range(0,len(cell)):
    temp = cell[i].split(',');
    cell_name.append(temp[0]);
    values.append(temp[1:]);

#make gene and cell into pickle
dep = pd.DataFrame( values, index = cell_name, columns = gene);
dep = dep.replace({'NA':np.nan})
dep = dep.astype('float')
print(dep)
dep.to_pickle('update_data/ceres.pkl')
#'''

#exp Extracting EXPRESSION 19Q3 to pickle data form
'''f = open("update_data/public_data/EXPRESSION_19Q4.csv", "r")

#extract gene name and remove HGNC
gene = f.readline()
gene = np.array(gene.replace('\n','').replace('.','_').split(','));
gene = gene[1:];
i = 0;
while i <len(gene):
    start = 0;
    start = gene[i].find(' ',0);
    gene[i] = gene[i][0:start];
    i = i + 1;

#extract cell line and values
cell = f.read();
f.close();
cell = cell.split('\n');
cell = cell[0:len(cell)-1];
values = np.zeros((len(cell),len(gene)));
cell_name = [];
for i in range(0,len(cell)):
    temp = cell[i].split(',');
    cell_name.append(temp[0]);
    values[i] = temp[1:];

#make gene and cell into pickle
exp = pd.DataFrame( values, index = cell_name, columns = gene);
print(exp)
exp.to_pickle('update_data/exp_original.pkl')
#'''

'''
dep = pd.read_pickle('update_data/ceres.pkl')
exp = pd.read_pickle('update_data/exp_original.pkl')
exp = exp.reindex( index = dep.index, columns = dep.columns)
exp.to_pickle('update_data/exp_ceres.pkl');
#'''

#cnv
'''f = open("update_data/public_data/CNV.csv", "r")
#extract gene name and remove HGNC
gene = f.readline()
gene = np.array(gene.replace('\n','').replace('.','_').split(','));
gene = gene[1:];
i = 0;
while i <len(gene):
    start = 0;
    start = gene[i].find(' ',0);
    gene[i] = gene[i][0:start];
    i = i + 1;
print(gene)

#extract cell line and values
cell = f.read();
f.close();
cell = cell.split('\n');
cell = cell[0:len(cell)-1];
values = np.zeros((len(cell),len(gene)));
cell_name = [];
for i in range(0,len(cell)):
    temp = cell[i].split(',');
    cell_name.append(temp[0]);
    values[i] = temp[1:];

#make gene and cell into pickle
exp = pd.DataFrame( values, index = cell_name, columns = gene);
print(exp)
exp.to_pickle('update_data/cnv_original.pkl')
#'''

'''dep = pd.read_pickle('update_data/ceres.pkl')
exp = pd.read_pickle('update_data/cnv_original.pkl')
exp = exp.reindex( index = dep.index, columns = dep.columns)
exp.to_pickle('update_data/cnv_ceres.pkl');
#'''

#sample extracting sample data
'''sample = pd.read_csv('update_data/public_data/sample.csv', index_col = 0);
sample.to_pickle('update_data/sample_original.pkl');
dep = pd.read_pickle('update_data/ceres.pkl')
sample = sample.reindex( index = dep.index)
sample.to_pickle('update_data/sample_ceres.pkl');
#'''

#dep-exp cor calculation
'''dep = pd.read_pickle('update_data/ceres.pkl')
exp = pd.read_pickle('update_data/exp_ceres.pkl')
exp = exp.dropna(how = 'all')
dep = dep.reindex(drug.index)

cor = pd.DataFrame(np.nan,index = exp.columns, columns = dep.columns)
for i in dep.columns:
    print(i)
    x = dep.loc[:,i].notnull()
    y = exp.loc[x,:]
    x = dep.loc[x,i]
    for j in y.columns:
        d_x = y.loc[:,j].notnull()
        cor_tmp = np.corrcoef(x[d_x].values.tolist(), y = y.loc[d_x,j].values.tolist())
        cor.loc[j,i] = cor_tmp[0][1];
print(cor)
cor.to_pickle('update_data/cor_all_dep_all_exp.pkl')
#'''

#slope analytical calculation
'''cor = pd.read_pickle('data_py/cor_all_dep_all_exp.pkl')
exp = pd.read_pickle('data_py/exp_ceres.pkl')
dep = pd.read_pickle('data_py/ceres.pkl')
exp = exp.dropna(how='all')
dep = dep.reindex(exp.index)
cor = cor / dep.std()
cor = cor.T
for i in cor.index:
    idx = dep.index[~dep.loc[:,i].isna()]
    cor.loc[i,:] = cor.loc[i,:] * exp.loc[idx,:].std()
cor.to_pickle('data_py/slope_all_dep_all_exp.pkl')
#'''

#c-score calcuation
#exp cut off at 0.5
'''cor = pd.read_pickle('update_data/cor_all_dep_all_dep.pkl')
exp = pd.read_pickle('update_data/exp_ceres.pkl')
x = exp.mean() >= 0.5
cor = cor.loc[x,x]
cor.to_pickle('update_data/dep_cor.pkl')
print('cor finished')
cor = pd.read_pickle('update_data/cor_all_dep_all_exp.pkl')
cor = cor.loc[x,x]
cor.to_pickle('update_data/exp_cor.pkl')
print('exp cor finished')
slope = pd.read_pickle('update_data/slope_all_dep_all_exp.pkl')
#slope is [dep,exp]
slope = slope.T
slope = slope.loc[x,x]
slope.to_pickle('update_data/slope.pkl')
print('slop finished')
slmin = slope.loc['THAP9','CCND1']
C = cor*(1+slmin/slope)
print(C)
C.to_pickle('update_data/c.pkl')
#'''

#dep cut off at 0
'''c = pd.read_pickle('update_data/c.pkl')
dep = pd.read_pickle('update_data/ceres.pkl')
x = dep.mean() > 0
c = c.loc[:,~x]
c.to_pickle('update_data/c.pkl')
print('finish c')
#'''

#slope modification
'''slope = pd.read_pickle('update_data/slope.pkl')
c = pd.read_pickle('update_data/c.pkl')
cor = pd.read_pickle('update_data/exp_cor.pkl')
slope = slope.reindex(index = c.index, columns = c.columns)
cor = cor.reindex(index = c.index, columns = c.columns)
slope_modify = slope * c / cor
print(slope_modify)
slope_modify.to_pickle('update_data/c_slope.pkl')
#'''

#cnv cor calculation
'''dep = pd.read_pickle('update_data/exp_ceres.pkl')
exp = pd.read_pickle('update_data/cnv_ceres.pkl')
exp = exp.dropna(how = 'all')
dep = dep.reindex(exp.index)

cor = pd.DataFrame(np.nan,index = dep.columns, columns = ['cor'])
for i in dep.columns:
    x = dep.loc[:,i].notnull()
    y = exp.loc[x,i]
    x = dep.loc[x,i]
    d_x = y.notnull()
    cor_tmp = np.corrcoef(x[d_x].values.tolist(), y = y.loc[d_x].values.tolist())
    cor.loc[i,'cor'] = cor_tmp[0][1];
print(cor)
cor.to_pickle('update_data/cor_self_exp_cnv.pkl')
#'''

