
print("loading")
d <- read.table("cor.csv",sep="\t")
print("loaded")

### IMPORTANT ###
# need to add a blank character in the "header" to make sure the columns matches!

slope_min = 10
g1_min = ""
g2_min = ""

print(paste(g1_min,g2_min,slope_min))
for ( i in seq(1,dim(d)[1],1) ) {
  g1 <- toString(d[i,1])  
  g2 <- toString(d[i,2])
  g1 <- gsub("\\.","-",g1)
  g2 <- gsub("\\.","-",g2)  
	if ( i %% 1000 == 0 ) {
		print(paste(i,g1,g2))
		Sys.time()
	}
  filename1 <- paste("../AllGenes/",g1, "_ds_expr.txt", sep="")
  filename2 <- paste("../AllGenes/",g2, "_ds_expr.txt", sep="")
  
  #	  print(filename1)
  #	  print(filename2)
  
  file1 <- read.table(filename1, header=T, sep="\t")
  file2 <- read.table(filename2, header=T, sep="\t")
  
  ds   <- file1$DS
  expr <- file2$Expr
 
  c <- cor.test(ds,expr)
  
  rho  <- c$estimate
  pval <- c$p.value
  
  #print(paste(g1,g2,rho,pval))
  
  if ( rho > 0 & pval > 0.05 ) { 
  	
  		ds.sd <- sd(ds)
  		expr.sd <- sd(expr)
  	
  		slope = rho * expr.sd/ds.sd
  		
    if ( slope < slope_min ) {
      slope_min <- slope
      g1_min = g1
      g2_min = g2
    }
  }
}

print(paste(g1_min,g2_min,slope_min))
pline <- c(g1_min, g2_min, slope_min)
write( pline, "slope_min.txt")
