clearvars

list = dir;
filename = {list(~[list(:).isdir]).name};
filename = filename(contains(filename,'.mat'));

db = ["KEGG" "GOBP" "GOCC" "GOMF" "STRING" "CORUM"];
enrichment = nan(length(filename),length(db));
ef = enrichment;
efc = enrichment;
ec = enrichment;
e = enrichment;

composition_cNet = nan(5,length(filename));
composition_KEGG = composition_cNet;
composition_GOBP = composition_cNet;
composition_GOCC = composition_cNet;
composition_GOMF = composition_cNet;
composition_STRING = composition_cNet;
composition_CORUM = composition_cNet;
composition_KEGG_cNet = composition_cNet;
composition_GOBP_cNet = composition_cNet;
composition_GOCC_cNet = composition_cNet;
composition_GOMF_cNet = composition_cNet;
composition_STRING_cNet = composition_cNet;
composition_CORUM_cNet = composition_cNet;
type = [1 2 3 4 8];
for i = 1:length(filename)
    load(filename{i})
    
    expression = 'log2_enrichment_(?<th>\d+)_over_1000_NtoN.mat';
    tokenNames = regexp(filename{i},expression,'names');
    th(i) = str2double(tokenNames.th);
    nD(i,1) = nDup;
    nS(i,1) = nSingleton;
    for j = 1:length(db)
        v = evalin('base', "score_"+db(j));
        enrichment(i,j) = v.enrichment;
        ef(i,j) = v.ef;
        e(i,j) = v.e;
        ec(i,j) = v.ec;
        efc(i,j) = v.efc;
        
    end
    for j = 1:length(type)
        try
            composition_cNet(j,i) = composition.cNet(composition.cNet(:,1)==type(j),2);
        end
        
        try
            composition_KEGG(j,i) = composition.KEGG(composition.KEGG(:,1)==type(j),2);
        end
        try
            composition_GOBP(j,i) = composition.GOBP(composition.GOBP(:,1)==type(j),2);
        end
        try
            composition_GOCC(j,i) = composition.GOCC(composition.GOCC(:,1)==type(j),2);
        end
        try
            composition_GOMF(j,i) = composition.GOMF(composition.GOMF(:,1)==type(j),2);
        end
        try
            composition_STRING(j,i) = composition.ppin(composition.ppin(:,1)==type(j),2);
        end
        try
            composition_CORUM(j,i) = composition.corum(composition.corum(:,1)==type(j),2);
        end
        
        try
            composition_KEGG_cNet(j,i) = composition.KEGG_cNet(composition.KEGG_cNet(:,1)==type(j),2);
        end
        try
            composition_GOBP_cNet(j,i) = composition.GOBP_cNet(composition.GOBP_cNet(:,1)==type(j),2);
        end
        try
            composition_GOCC_cNet(j,i) = composition.GOCC_cNet(composition.GOCC_cNet(:,1)==type(j),2);
        end
        try
            composition_GOMF_cNet(j,i) = composition.GOMF_cNet(composition.GOMF_cNet(:,1)==type(j),2);
        end
        try
            composition_STRING_cNet(j,i) = composition.ppin_cNet(composition.ppin_cNet(:,1)==type(j),2);
        end
        try
            composition_CORUM_cNet(j,i) = composition.corum_cNet(composition.corum_cNet(:,1)==type(j),2);
        end
    end
end
% tbl = array2table(enrichment,'VariableNames',db);
%%
[th,I] = sort(th);
nD = nD(I);
nS = nS(I);
e = e(I,:);
ef = ef(I,:);
ec = ec(I,:);
efc = efc(I,:);
enrichment = enrichment(I,:);
composition_cNet = composition_cNet(:,I);

composition_KEGG = composition_KEGG(:,I);
composition_GOBP = composition_GOBP(:,I);
composition_GOCC = composition_GOCC(:,I);
composition_GOMF = composition_GOMF(:,I);
composition_STRING = composition_STRING(:,I);
composition_CORUM = composition_CORUM(:,I);

composition_KEGG_cNet = composition_KEGG_cNet(:,I);
composition_GOBP_cNet = composition_GOBP_cNet(:,I);
composition_GOCC_cNet = composition_GOCC_cNet(:,I);
composition_GOMF_cNet = composition_GOMF_cNet(:,I);
composition_STRING_cNet = composition_STRING_cNet(:,I);
composition_CORUM_cNet = composition_CORUM_cNet(:,I);
%%
total = nD+nS;
figure
hold on
plot(th/1000,nD./total*100,'LineWidth',2)
plot(th/1000,nS./total*100,'LineWidth',2)
hold off
xlabel("C-score cutoff")
ylabel("%")
set(gca,'LineWidth',2,'FontWeight','bold','FontSize',16)
legend(["Duplicated" "Singleton"],'Location','best','Box','off')
ylim([0 100])
%%
close
x = composition_cNet;
total = nansum(x);
figure
hold on
plot(th/1000,x./total*100,'LineWidth',2)
hold off
xlabel("C-score cutoff")
ylabel("%")
set(gca,'LineWidth',2,'FontWeight','bold','FontSize',16)
legend(["S-to-S" "D-to-S" "S-to-D" "D-to-D" "P-to-P"],'Location','best','Box','off')
title('CORUM\capcNet')
% title('KEGG')
ylim([0 100])
%%
close
figure
b = bar(th/1000,enrichment(:,[2 1])',1,'edgecolor','none');
b(1).FaceColor = [243 117 109]./255;
b(2).FaceColor = [28 189 194]./255;
legend(db([2 1]))
xlabel('C-score cutoff')
ylabel('Enrichment(log_2)')
set(gca,'fontsize',14,'fontweight','bold')

figure
b = bar(th/1000,enrichment(:,[6 5])',1,'edgecolor','none');
b(1).FaceColor = [153 152 153]./255;
b(2).FaceColor = [231 160 35]./255;
legend(db([6 5]))
xlabel('C-score cutoff')
ylabel('Enrichment(log_2)')
set(gca,'fontsize',14,'fontweight','bold')

tbl = table(th'/1000,enrichment(:,2),enrichment(:,1),enrichment(:,6),enrichment(:,5),...
    'VariableNames',["cutoff" db([2 1 6 5])]);
writetable(tbl,'enrichment_N.csv')
%%
close
x = th/1000;
% tbl = array2table([x',enrichment],'VariableNames',["cutoff" db]);
% save("enrichment_p2p.mat","tbl")
% tiledlayout('flow','Padding','none','TileSpacing','none')
% nexttile
lineColor = ["4DBBD5" "00A087" "8491B4"]';
hex2rgb = @(x) reshape(sscanf(x.','%2x'),3,[]).'/255;
lineColor = cell2mat(arrayfun(@(x) hex2rgb(x),lineColor,'UniformOutput',0));

% tiledlayout('flow','Padding','none','TileSpacing','none')
% nexttile
figure
% colororder(lineColor)

x1 = 0:0.025:0.5;
y1 = interp1(x,enrichment(:,1),x1);
y2 = interp1(x,enrichment(:,2),x1);
y3 = interp1(x,enrichment(:,3),x1);
y4 = interp1(x,enrichment(:,4),x1);
y5 = interp1(x,enrichment(:,5),x1);
y6 = interp1(x,enrichment(:,6),x1);

y7 = interp1(x,nD,x1);
y8 = interp1(x,nS,x1);

% plot(x,enrichment(:,[1 5 6]),'LineWidth',2)
plot(x1,[y1;y2;y3;y4;y5;y6],'LineWidth',2)
% ylim([0 5])
% xlim([0 0.4])
xlabel("C-score cutoff")
ylabel("log2 enrichment")
set(gca,'LineWidth',2,'FontWeight','bold','FontSize',16)
legend(db,'Location','best','Box',0)
box off

figure
plot(x1,[y1;y2;y3;y4],'LineWidth',2)
% ylim([0 2])
% xlim([0 0.4])
xlabel("C-score cutoff")
ylabel("log2 enrichment")
set(gca,'LineWidth',2,'FontWeight','bold','FontSize',16)
legend(db([1 2 3 4]),'Location','best','Box',0)
box off

figure
yyaxis left
plot(x1,[y1],'LineWidth',2)
ylim([0 5])
yyaxis right
plot(x1,[y2;y3;y4],'LineWidth',2)
ylim([0 5])
% xlim([0 0.4])
xlabel("C-score cutoff")
ylabel("log2 enrichment")
set(gca,'LineWidth',2,'FontWeight','bold','FontSize',16)
legend(db([1 2 3 4]),'Location','best','Box',0)
box off

figure
plot(x1,[y7./(y7+y8);y8./(y7+y8)].*100,'LineWidth',2)
xlabel("C-score cutoff")
ylabel("%")
set(gca,'LineWidth',2,'FontWeight','bold','FontSize',16)
legend(["Duplicated" "Singleton"],'Location','best','Box',0)

%%
close
figure
b = bar(enrichment(11,[1 5 6]),'EdgeColor','none');
b.FaceColor = 'flat';
b.CData = lineColor;
xticklabels(db([1 5 6]))
set(gca,'LineWidth',2,'FontWeight','bold','FontSize',16)
box off
ylabel("log2 enrichment")
% 
% nexttile
% plot(x,e)
% legend(db,'Location','best')
% xlabel("C-score cutoff")
% title("e")
% 
% nexttile
% plot(x,ec)
% legend(db,'Location','best')
% xlabel("C-score cutoff")
% title("ec")
% 
% nexttile
% plot(x,ef)
% legend(db,'Location','best')
% xlabel("C-score cutoff")
% title("ef")
% 
% nexttile
% plot(x,efc)
% legend(db,'Location','best')
% xlabel("C-score cutoff")
% title("efc")