% clearvars
% tic;arrayfun(@fig5a,0:0.005:0.5);toc
function fig5a(th)

load('fig5a.mat')
load('..\..\20200504\HK_cNet.mat')
% load('..\..\20200504\HK_gcNet.mat')
% G = GC;
opts = detectImportOptions('gene_dep_exp.info.txt');
genedepexp = readtable('gene_dep_exp.info.txt',opts);
th
% [bin,binsize] = conncomp(H,'Type','weak');
% [~,I] = max(binsize);
% G = subgraph(H,bin==I);
% th = 0.25;
G = rmedge(G,find(G.Edges.Weight<=th));
% G = H;
G = subgraph(G,G.indegree+G.outdegree>0);

node = G.Nodes.Name;

load('paralog_family.mat')
index = arrayfun(@(x)find(ismember(paralogFam.gene,x)),node,'UniformOutput',0);
index = [find(cellfun(@numel,index)>0) cell2mat(index)]; % node belongs to some paralog family
isDupGene = false(length(node),1);
isDupGene(index(:,1)) = 1;

G1 = repmat(isDupGene,1,length(node));
G2 = repmat(isDupGene',length(node),1);
paralog = false(length(node));
paralog(index(:,1),index(:,1)) = paralogFam.mat(index(:,2),index(:,2));
edgeType = paralog*4+G1*2+G2*1+1; % 0:singleton; 1:duplicated
% 8: p-to-p; 4: d-to-d; 3: s-to-d; 2: d-to-s; 1: s-to-s

% [r,c,v] = find(G.adjacency);
% ind = sub2ind(size(G.adjacency),r,c);
% G.Edges.edgeType = edgeType(ind)-1;

% for specific edge type
cNet1 = full(G.adjacency.*edgeType);
cNet1(cNet1==8) = 0;

G = digraph(cNet1,node); % create a network consised of a specific interaction type
G = subgraph(G,G.indegree+G.outdegree>0); % remove isolated genes
node = G.Nodes.Name;

index = arrayfun(@(x)find(ismember(paralogFam.gene,x)),node,'UniformOutput',0);
index = [find(cellfun(@numel,index)>0) cell2mat(index)]; % node belongs to some paralog family
isDupGene = false(length(node),1);
isDupGene(index(:,1)) = 1;

G1 = repmat(isDupGene,1,length(node));
G2 = repmat(isDupGene',length(node),1);
paralog = false(length(node));
paralog(index(:,1),index(:,1)) = paralogFam.mat(index(:,2),index(:,2));
edgeType = paralog*4+G1*2+G2*1+1; % 0:singleton; 1:duplicated
% 8: p-to-p; 4: d-to-d; 3: s-to-d; 2: d-to-s; 1: s-to-s

% isDup = arrayfun(@(x) genedepexp.Paralog_num(strcmp(genedepexp.Gene,x))>0,node);
nDup = nnz(isDupGene);
nSingleton = nnz(~isDupGene);

adj = G.adjacency;
cNet = adj;
adj = adj+adj';
adj = adj>0;
adj(1:size(adj,1)+1:end) = 0;

KEGG = matrixize(kegg,node);
GOBP = matrixize(gobp,node);
GOCC = matrixize(gocc,node);
GOMF = matrixize(gomf,node);
corum = matrixize(CORUM,node);

tmp = ismember(ppi(:,1),node) & ismember(ppi(:,2),node);
PPI = ppi(tmp,:);

I = [];
J = [];
parfor i = 1:size(PPI,1)
    I(i) = find(strcmp(node,PPI(i,1)));
    J(i) = find(strcmp(node,PPI(i,2)));
end
ppin = sparse(I,J,ones(length(I),1),length(node),length(node));
ppin = ppin>0;

score_STRING = enrichment(ppin,adj);
score_GOBP = enrichment(GOBP,adj);
score_GOMF = enrichment(GOMF,adj);
score_GOCC = enrichment(GOCC,adj);
score_KEGG = enrichment(KEGG,adj);
score_CORUM = enrichment(corum,adj);

score = [score_GOBP.enrichment,...
    score_GOMF.enrichment,score_GOCC.enrichment,score_KEGG.enrichment,...
    score_STRING.enrichment,score_CORUM.enrichment];
% bar(score)
% ylabel('Log2 enrichment')
% xticklabels(["GO BP" "GO MF" "GO CC" "KEGG" "STRING" "CORUM"])

cNet1 = full(cNet.*edgeType);
composition.cNet = tabulate(cNet1(:));
tmp = triu(KEGG.*edgeType,1);
composition.KEGG = tabulate(tmp(:));
tmp = triu(GOBP.*edgeType,1);
composition.GOBP = tabulate(tmp(:));
tmp = triu(GOCC.*edgeType,1);
composition.GOCC = tabulate(tmp(:));
tmp = triu(GOMF.*edgeType,1);
composition.GOMF = tabulate(tmp(:));
tmp = triu(corum.*edgeType,1);
composition.corum = tabulate(tmp(:));
tmp = triu(full(ppin.*edgeType),1);
composition.ppin = tabulate(tmp(:));

tmp = KEGG.*cNet1;
composition.KEGG_cNet = tabulate(tmp(:));
tmp = GOBP.*cNet1;
composition.GOBP_cNet = tabulate(tmp(:));
tmp = GOCC.*cNet1;
composition.GOCC_cNet = tabulate(tmp(:));
tmp = GOMF.*cNet1;
composition.GOMF_cNet = tabulate(tmp(:));
tmp = corum.*cNet1;
composition.corum_cNet = tabulate(tmp(:));
tmp = full(ppin.*cNet1);
composition.ppin_cNet = tabulate(tmp(:));

toc
filename = sprintf('log2_enrichment_%d_over_1000_NtoN.mat',int16(th*1000));
save(filename,'score_STRING','score_GOBP','score_GOMF','score_GOCC',...
    'score_KEGG','score_CORUM','score','nDup','nSingleton','composition');
end

function Path = matrixize(pathway,node)
Path = (false(length(node),length(node)));
for i = 1:length(pathway)
    index = find(ismember(node,pathway(i).gene));
    if ~isempty(index)
        Path(index,index) = 1;
    end
end
end

function score = enrichment(c,f)
ef = nnz(triu(f,1)); % number of co-functional pairs
ec = nnz(triu(c,1)); % number of co-annotated pairs
efc = nnz(triu(f&c,1));
eA = (size(c,1)^2-size(c,1))/2;
enrichment = log2((efc/ec)/(ef/eA));

score.ef = ef;
score.ec = ec;
score.efc = efc;
score.e = eA;
score.enrichment = enrichment;

end
