import matplotlib
matplotlib.use('Agg')
import matplotlib.pyplot as plt
import pickle
import pandas as pd
import numpy as np

def save_obj( data, name ):
    with open(name,'wb') as f:
        pickle.dump(data, f, protocol=pickle.HIGHEST_PROTOCOL);


def load_obj( name ):
    with open(name,'rb') as f:
        return pickle.load(f);

##############
#CNV analysis#
##############
#c_max calculation
'''c = pd.read_pickle('update_data/c.pkl')
ma = pd.DataFrame(c.max(axis = 1), columns = ['max'])
ma.loc[:,'g1'] = c.idxmax(axis = 1)
ma.to_pickle('update_data/c_max.pkl')
#'''

'''c = pd.read_pickle('update_data/c.pkl')
tmp = pd.DataFrame(c.max(),columns = ['max'])
tmp.loc[:,'g2'] = c.idxmax()
tmp.to_pickle('update_data/c_max_g1.pkl')
#'''

#correlation reindex
'''cnv = pd.read_pickle('update_data/cor_all_dep_all_cnv.pkl')
c = pd.read_pickle('update_data/c.pkl')
print(cnv)
cnv = cnv.reindex(index = c.index,columns = c.columns)
print(cnv)
cnv.to_pickle('update_data/cor_cnv.pkl')
#'''

#c_stack calculation
'''c = pd.read_pickle('update_data/c.pkl')
s = c.stack()
s.to_pickle('update_data/c_stack.pkl')
#'''

#paralog mapping
'''paralog = pd.read_csv('update_data/paralog_family.txt', header = None, sep = '\t', index_col = 0)
print(paralog)
c = pd.read_pickle('update_data/c.pkl')
gene = []
for i in paralog.index:
    tmp = paralog.loc[i,1].split(',')
    gene += tmp
print(len(gene))
result = pd.DataFrame(np.nan, index = gene, columns = ['family'])
for i in paralog.index:
    tmp = paralog.loc[i,1].split(',')
    result.loc[tmp,'family'] = i
result = result.reindex(c.index)
cnt = result.loc[:,'family'].max() + 1
for i in result.index[result.loc[:,'family'].isna()]:
    result.loc[i,'family'] = cnt
    cnt += 1
print(result)
result.to_pickle('update_data/paralog_mapping.pkl')
#'''

#c link list
'''cs = pd.read_pickle('update_data/c_stack.pkl')
cs = cs[cs > 0.25]
g2 = cs.index.get_level_values(0)
g1 = cs.index.get_level_values(1)
idx = g2+'_'+g1
print(idx)
clink = pd.DataFrame(cs.values, index = idx, columns = ['c'])
clink.to_pickle('update_data/c_link.pkl')
#'''

#clink list with paralog information
'''clink = pd.read_pickle('update_data/c_link.pkl')
paralog = pd.read_pickle('update_data/paralog_mapping.pkl')
for i in clink.index:
    print(i)
    g2, g1 = i.split('_')
    if paralog.loc[g2,'family'] == paralog.loc[g1,'family']:
        clink.loc[i,'p'] = 1
clink.loc[:,'p'].fillna(0, inplace = True)
print(clink)
clink.to_pickle('update_data/c_link_p.pkl')
#'''

#clink list transformation
'''cor_cnv = pd.read_pickle('update_data/cor_cnv.pkl')
clink = pd.read_pickle('update_data/c_link_p.pkl')
for i in clink.index:
    print(i)
    g2, g1 = i.split('_')
    clink.loc[i,'g2'] = g2
    clink.loc[i,'g1'] = g1
    clink.loc[i,'cnv_dep'] = cor_cnv.loc[g2,g1]
clink = clink.sort_values(by = ['c'], ascending = False)
print(clink)
clink.to_pickle('update_data/c_link_p_cnv.pkl')
#'''

#clink list self
'''clink = pd.read_pickle('update_data/c_link_p_cnv.pkl')
g2 = list(pd.unique(clink.loc[:,'g2']))
cor = pd.read_pickle('update_data/cor_self_exp_cnv.pkl')
for i in g2:
    clink.loc[clink.loc[:,'g2'] == i,'self_cnv_exp'] = cor.loc[i,'cor']
clink.to_pickle('update_data/c_link_p_cnv_self.pkl')
#'''

#randomization bin
'''exp = pd.read_pickle('update_data/exp_ceres.pkl')
c = pd.read_pickle('update_data/c.pkl')
exp = exp.reindex(columns = c.index)

expstd = exp.mean()
expmean = exp.std()
expstd = expstd.sort_values()
rand = []
for i in exp.columns:
    start = expstd.index.get_loc(i)
    print(i)
    d = int( len(expstd)/100 )
    rbin = expstd.iloc[ int(start/d) *d: (int(start/d)*d + d)].index.tolist()
    rbin.remove(i)
    rand.append(rbin)
#print(rand)
save_obj( rand, 'update_data/cnv_random_bin_2.pkl' )
#'''

#random only std
'''import random as rd
rd.seed(0)
cor = pd.read_pickle('update_data/cor_self_exp_cnv.pkl')
randbin = load_obj( 'update_data/cnv_random_bin_std.pkl' )
cmax = pd.read_pickle('update_data/c_max.pkl')
idx = [ i for i in range(0,len(cmax))]
cmax.loc[:,'idx'] = idx
cmax = cmax.loc[cmax.loc[:,'max'] > 0.40,:]
out = []
for i in cmax.index:
    out.append(randbin[cmax.loc[i,'idx']])
randbin = out
index = [ i for i in range(0,10000)]
control = pd.DataFrame(np.nan, index = index, columns = ['mean'])
for time in range(0,10000):
    print(time)
    gene_num = []
    for i in range(0,len(randbin)):
        #print(len(randbin[i]))
        gene_num.append(cor.loc[randbin[i][rd.randrange(len(randbin[i]))],'cor'])
    #print(gene_num)
    aver = np.nanmean(gene_num)
    control.loc[time,'mean'] = np.nanmean(gene_num)
print(control)
print(control.mean())
print(control.std())
control.to_pickle('update_data/cnv_control_40_10000.pkl')
#'''

#randomi exp
'''import random as rd
rd.seed(0)
cor = pd.read_pickle('update_data/cor_self_exp_cnv.pkl')
randbin = load_obj( 'update_data/cnv_random_bin_2.pkl' )
cmax = pd.read_pickle('update_data/c_max.pkl')
idx = [ i for i in range(0,len(cmax))]
cmax.loc[:,'idx'] = idx
cmax = cmax.loc[cmax.loc[:,'max'] > 0.5,:]
out = []
for i in cmax.index:
    out.append(randbin[cmax.loc[i,'idx']])
randbin = out
index = [ i for i in range(0,10000)]
control = pd.DataFrame(np.nan, index = index, columns = ['mean'])
for time in range(0,10000):
    print(time)
    gene_num = []
    for i in range(0,len(randbin)):
        #print(len(randbin[i]))
        gene_num.append(cor.loc[randbin[i][rd.randrange(len(randbin[i]))],'cor'])
    #print(gene_num)
    aver = np.nanmean(gene_num)
    control.loc[time,'mean'] = np.nanmean(gene_num)
print(control)
print(control.mean())
print(control.std())
control.to_pickle('update_data/cnv_control_50_10000_exp.pkl')
#'''

#randomization result
'''import os.path as path
cor = pd.read_pickle('update_data/cor_self_exp_cnv.pkl')
c = pd.read_pickle('update_data/c.pkl')
cor = cor.reindex(c.index)
import scipy.stats as stat
clink = pd.read_pickle('update_data/c_link_p_cnv_self.pkl')
result = pd.DataFrame(np.linspace(0.25,0.5,num = 6), columns = ['cut'])
exp = pd.read_pickle('update_data/exp_ceres.pkl')
c = pd.read_pickle('update_data/c.pkl')
cmax = pd.read_pickle('update_data/c_max.pkl')
exp = exp.reindex(columns = c.index)
expstd = exp.std()
expmean = exp.mean()
for i in result.index:
    clink = clink.loc[ clink.loc[:,'c'] > result.loc[i,'cut'],:]
    result.loc[i,'cnvdep'] = clink.loc[:,'cnv_dep'].mean()
    result.loc[i,'selfcnv'] = clink.loc[:,'self_cnv_exp'].mean()
    g2 = list(pd.unique(clink.loc[:,'g2']))
    a = cor.reindex(g2).loc[:,'cor'].dropna()
    b = cor.loc[:,'cor'].dropna()
    result.loc[i,'selfcnv_t'], result.loc[i,'selfcnv_p'] = stat.ttest_ind(a,b)
    result.loc[i,'g2_num'] = len(g2)
    result.loc[i,'g2_mean'] = expmean.loc[g2].mean()
    result.loc[i,'g2_std'] = expstd.loc[g2].mean()
    if path.exists('update_data/cnv_control_'+str(int(result.loc[i,'cut']*100))+'_10000.pkl'):
        control = pd.read_pickle('update_data/cnv_control_'+str(int(result.loc[i,'cut']*100))+'_10000.pkl')
        result.loc[i,'control_std'] = control.mean().values
        result.loc[i,'control_p'] = (control < result.loc[i,'selfcnv']).sum().values/10000
    if path.exists('update_data/cnv_control_'+str(int(result.loc[i,'cut']*100))+'_10000_exp.pkl'):
        control = pd.read_pickle('update_data/cnv_control_'+str(int(result.loc[i,'cut']*100))+'_10000_exp.pkl')
        result.loc[i,'control_exp'] = control.mean().values
        result.loc[i,'control_p_exp'] = (control < result.loc[i,'selfcnv']).sum().values/10000
print(result)
out = []
for i in ['selfcnv','control_std','control_exp']:
    tmp = result.loc[:,['cut',i]]
    tmp = tmp.rename(columns = {i:'selfcnv_cor'})
    tmp.loc[:,'type'] = i
    out.append(tmp)
result = pd.concat(out)
print(result)
result.to_csv('working_data/c_cnv_relation.csv')
#'''
