library(ggplot2)

d <- read.table("Cscore_G1G2/enriched_functions.txt",header=T, sep='\t')

d <- d[order(d$Client.Text.Box.Input..FDR.)]
d <- d[1:10, ]

fig<-ggplot(d, aes(x=reorder(PANTHER.GO.Slim.Biological.Process, -log(Client.Text.Box.Input..FDR.)) , y=-log(Client.Text.Box.Input..FDR.))) +
	geom_col() +
	coord_flip() +
	labs(x="", y='-log FDR') +
	theme( panel.background = element_blank(), axis.line = element_line(color="black"),legend.position = "none",
								axis.text=element_text(size=15, color="black"), axis.title=element_text(size=15, color="black"))

fig
ggsave( "D:/Cscore/Cscore_G1G2/enriched_functions.svg", fig, device='svg', height=4, width=9)
