import argparse
import pandas as pd
import numpy as np
import pickle
import os
from datetime import datetime

parser = argparse.ArgumentParser()
parser.add_argument('-mut')
parser.add_argument('-start', type=int)
parser.add_argument('-end', type=int)
parser.add_argument('-outpath')

args = parser.parse_args()
mutfile = args.mut
start   = args.start
end     = args.end
outpath = args.outpath

mut = pd.read_pickle(mutfile)

cellline = mut["DepMap_ID"].unique()
genelist = mut["Hugo_Symbol"].unique()

genelist = genelist[start:end]

wildtype = pd.DataFrame(1, index=cellline, columns=genelist)
damaging = pd.DataFrame(0, index=cellline, columns=genelist)
other = pd.DataFrame(0, index=cellline, columns=genelist)

for g in genelist:
	print(g)
	mut_gene = mut[ mut['Hugo_Symbol'] == g ]
	mut_cell = mut_gene["DepMap_ID"].unique()
	for c in mut_cell:
		mut_genecell = mut_gene[mut_gene['DepMap_ID'] == c ]
	
		mut_type = mut_genecell['Variant_annotation'].to_numpy()
		if 'damaging' in mut_type:
			damaging.at[c, g] = 1
			wildtype.at[c, g] = 0
		elif 'other non-conserving' in mut_type or 'other conserving' in mut_type:
			other.at[c, g] = 1
			wildtype.at[c, g] = 0
	

fname = os.path.splitext( mutfile )[0]

wt_fname = outpath + '/' + fname + '.wildtype_matrix' + str(start) +'-' + str(end) +'.pkl'
dam_fname = outpath + '/' + fname + '.damaging_matrix' + str(start) + '-' + str(end) + '.pkl'
other_fname = outpath + '/' + fname + '.other_matrix' + str(start) + '-' + str(end) + '.pkl'

wildtype.to_pickle(wt_fname)
damaging.to_pickle(dam_fname)
other.to_pickle(other_fname)

'''
for i in range( len(mut) ):
	if i % 100000 == 0:
		print (i)
	var_ann = mut.at[i, "Variant_annotation"]
	gene = mut.at[i, "Hugo_Symbol"]
	cell = mut.at[i, "DepMap_ID"]
    
	if var_ann == 'damaging':
		del_mut.at[cell, gene] = 1
	elif 'other' in var_ann
	
if var_ann == "silent" or var_ann == "nan":
        wildtype.at[cell, gene] = 1
    elif var_ann == "damaging":
        del_mut.at[cell, gene] = 1
    else:
        other_mut.at[cell, gene] = 1

'''
