import numpy as np
import pandas as pd
import sys
import pickle

num = sys.argv[1]

dep = pd.read_pickle('ceres.pkl')
pos_dep = dep.mean() > 0
dep = dep.loc[:,~pos_dep]

exp = pd.read_pickle('shuffled_ccle_expression_'+str(num)+'.pkl')
exp = exp.dropna(how = 'all')
high_exp = exp.mean() >= 0.5
exp = exp.loc[:, high_exp]
exp.set_index(dep.index, inplace=True)

dep = dep.reindex(columns=exp.columns)
dep = dep.dropna(axis='index', how='all')
dep = dep.dropna(axis='columns', how='all')


#exp = exp.reindex(columns=dep.columns)
exp = exp.dropna(axis='index', how='all')
exp = exp.dropna(axis='columns', how='all')

print('calculating correlation')
cor = pd.DataFrame(np.nan,index = exp.columns, columns = dep.columns)
for i in dep.columns:
	print(i)
	x = dep.loc[:,i].notnull()
	y = exp.loc[x,:]
	x = dep.loc[x,i]
	for j in y.columns:
		d_x = y.loc[:,j].notnull()
		cor_tmp = np.corrcoef(x[d_x].values.tolist(), y = y.loc[d_x,j].values.tolist())
		cor.loc[j,i] = cor_tmp[0][1];
print('correlation finished')
print(cor)
cor.to_pickle('cor_all_dep_all_exp_'+str(num)+'.pkl')

print('calculating slope')
slope = pd.DataFrame(np.nan,index = exp.columns, columns = dep.columns)
#slope analytical calculation
slope = cor / dep.std()
slope = slope.T

print(dep.index)

for i in slope.index:
	print(i)
	idx = dep.index[~dep.loc[:,i].isnull()]
	slope.loc[i,:] = slope.loc[i,:] * exp.loc[idx,:].std()
slope.to_pickle('slope_all_dep_all_exp_'+str(num)+'.pkl')
print(slope)
print('slope finished')

#cor = pd.read_pickle('cor_all_dep_all_exp_'+str(num)+'.pkl')
#slope = pd.read_pickle('slope_all_dep_all_exp_'+str(num)+'.pkl')

for i in slope.columns:
	slope[i] = slope[i].apply(lambda x: np.nan if abs(x) < 0.00748 else x)
	#print(i, np.nanmin(abs(slope[i])))

#slope_list = slope.values.flatten()
#slope_list = slope[~np.isnan(slope)]

#print( np.nanmin(abs(slope_list)) )


slmin = 0.00748
c = cor*(1+slmin/slope)
print(c)

c.to_pickle('c_rand_new_'+str(num)+'.pkl')
print('finish c')

