import pandas as pd
import numpy as np

import matplotlib
matplotlib.use('AGG')
import matplotlib.pyplot as plt
import seaborn as sns

import random

import argparse

parser = argparse.ArgumentParser()
parser.add_argument( '-cscore' )
parser.add_argument( '-rand' )
parser.add_argument( '-out' ) #cscore_distribution_wide.svg

args = parser.parse_args()

cscore_file = args.cscore
rand_file = args.rand
outfile = args.out

cscore = pd.read_pickle( cscore_file )
print( 'finished reading cscore_file' )
rand = pd.read_pickle( rand_file )
print( 'finished reading rand' )

for i in cscore:
	cscore.at[i,i] = np.nan

print( 'removed g1-g1' )

cscore_list = cscore.values.flatten()
cscore_list = cscore_list[~np.isnan(cscore_list)]

print( 'flattened cscore' )

#print( 'sampled dup and non-dup' )
rand_list = rand.values.flatten()
rand_list = rand_list[~np.isnan(rand_list)]
#rand_samp = random.sample( list(rand_list), 50000 )

print( 'flattened rand' )

m = np.nanmax(rand_list)

print( 'max of rand is ' + str(m) )

#dup_list = dup_list[dup_list > 0.25]
#ndup_list = ndup_list[ndup_list > 0.25]
#rand_list = rand_list[rand_list > 0.25]

print( 'plotting...')

plt.figure(figsize=(30,7.5))
plt.axvline(0.25, color='#808080', linestyle='--')
plt.axvline(0.35, color='#808080', linestyle='--')
plt.axvline(0.45, color='#808080', linestyle='--')
sns_plot = sns.kdeplot(cscore_list, color='b', shade=True)
sns_plot = sns.kdeplot(rand_list, color='#808080', shade=True, bw_adjust=5)
sns_plot.set(xlim=(-0.4, 0.6))
#sns_plot.set(ylim=(0,0.1))
sns_plot = sns_plot.get_figure()
sns_plot.savefig(outfile,format='svg')


