import matplotlib
matplotlib.use('Agg')
import matplotlib.pyplot as plt
import pickle
import pandas as pd
import numpy as np

def save_obj( data, name ):
    with open(name,'wb') as f:
        pickle.dump(data, f, protocol=pickle.HIGHEST_PROTOCOL);


def load_obj( name ):
    with open(name,'rb') as f:
        return pickle.load(f);

##############################################################
#tcga survival analysis
##############################################################
#transcription data
'''ens = pd.read_pickle('update_data/entrez.pkl')
c = pd.read_pickle('update_data/c.pkl')
ens = ens.reindex(c.index)
from gprofiler import GProfiler
gp = GProfiler(return_dataframe=True)
result = gp.convert(organism = 'hsapiens',
        query = ens.loc[:,'entrez'].values.tolist(),
        numeric_namespace = 'ENTREZGENE_ACC',
        target_namespace = 'ENSG')
print(result)
result.to_pickle('update_data/result_entrez.pkl')
#'''

'''f = open("update_data/tcga_RSEM_gene_tpm", "r")
result = pd.read_pickle('update_data/result_entrez.pkl')
head = f.readline()
head = head[0:len(head)-1]
head = np.array(head.split('\t'));
head = head[1:]

gene_name = []
value = []
while True:
    gene = f.readline()
    if (len(gene) == 0) | (gene == '\n'):
        break;
    gene = gene[0:len(gene)-1]
    gene = np.array(gene.split('\t'));
    real_gene = gene[0].split('.')
    if real_gene[0] in result.index:
        gene_name.append(result.loc[real_gene[0],'name'])
        #print(result.loc[real_gene[0],'name'])
        value.append(gene[1:])
#print(gene_name)
value = np.array(value)
print(value.shape)
final = pd.DataFrame(value, columns = head)
final = final.astype('float64')
final.to_pickle('update_data/tcga_exp_sym.pkl')
save_obj( gene_name, 'update_data/tcga_exp_name.pkl')
#'''

'''exp_d = pd.read_pickle('update_data/tcga_exp_sym.pkl')
exp = pd.read_pickle('update_data/tcga_exp_name.pkl')
exp = pd.DataFrame(exp)
exp = exp.drop_duplicates(keep = 'first')
exp_d = exp_d.loc[exp.index,:]
exp_d.index = exp.loc[:,0]
exp_d.to_pickle('update_data/tcga_exp_symbol.pkl')
print(exp_d)
#'''

#survival + sample
'''survival = pd.read_csv('update_data/tcga_surv', index_col = 0, sep = '\t')
exp = pd.read_pickle('update_data/tcga_exp_symbol.pkl')
survival = survival.reindex(exp.columns)
survival = survival.dropna(how='all')
exp = exp.reindex(columns = survival.index)
exp = exp.dropna(how='all', axis = 1)
survival.to_pickle('update_data/tcga_surv.pkl')
exp.to_pickle('update_data/tcga_exp.pkl')
print(survival)
print(exp)
#'''

'''surv = pd.read_pickle('update_data/tcga_surv.pkl')
cancer = pd.unique(surv.loc[:,'cancer type abbreviation'])
surv = surv.rename(columns = {'age_at_initial_pathologic_diagnosis':'age','ajcc_pathologic_tumor_stage':'patho_stage','histological_type':'type','histological_grade':'grade'})
print(surv.iloc[0,:])
#THYM I, II, III, IV
surv = surv.fillna('')
surv.loc[surv.loc[:,'gender'].str.contains('FEMALE'),'gender'] = '0'
surv.loc[surv.loc[:,'gender'].str.contains('MALE'),'gender'] = '1'
#surv.loc[surv.loc[:,'gender']!=np.nan,'gender'] = surv.loc[surv.loc[:,'gender']!=np.nan,'gender'].astype('float64')
surv.loc[surv.loc[:,'patho_stage'].str.contains('IV'),'patho_stage'] = '4'
surv.loc[surv.loc[:,'patho_stage'].str.contains('III'),'patho_stage'] = '3'
surv.loc[surv.loc[:,'patho_stage'].str.contains('II'),'patho_stage'] = '2'
surv.loc[surv.loc[:,'patho_stage'].str.contains('I'),'patho_stage'] = '1'
surv.loc[surv.loc[:,'patho_stage'].str.contains('0'),'patho_stage'] = '0'
surv.loc[ (surv.loc[:,'patho_stage'] != '4') &
        (surv.loc[:,'patho_stage'] != '3') &
        (surv.loc[:,'patho_stage'] != '2') &
        (surv.loc[:,'patho_stage'] != '1') &
        (surv.loc[:,'patho_stage'] != '0'),'patho_stage'] = np.nan
#surv.loc[surv.loc[:,'gender']!=np.nan,'gender'] = surv.loc[surv.loc[:,'gender']!=np.nan,'gender'].astype('float64')
surv.loc[surv.loc[:,'grade'].str.contains('G4'),'grade'] = '4'
surv.loc[surv.loc[:,'grade'].str.contains('G3'),'grade'] = '3'
surv.loc[surv.loc[:,'grade'].str.contains('G2'),'grade'] = '2'
surv.loc[surv.loc[:,'grade'].str.contains('G1'),'grade'] = '1'
surv.loc[surv.loc[:,'grade'].str.contains('High grade'),'Grade'] = '2'
surv.loc[surv.loc[:,'grade'].str.contains('Low grade'),'Grade'] = '1'
surv.loc[ (surv.loc[:,'grade'] != '4') &
        (surv.loc[:,'grade'] != '3') &
        (surv.loc[:,'grade'] != '2') &
        (surv.loc[:,'grade'] != '1'),'grade'] = np.nan
#surv.loc[surv.loc[:,'gender']!=np.nan,'gender'] = surv.loc[surv.loc[:,'gender']!=np.nan,'gender'].astype('float64')
surv.loc[surv.loc[:,'clinical_stage'].str.contains('IV'),'clinical_stage'] = '4'
surv.loc[surv.loc[:,'clinical_stage'].str.contains('III'),'clinical_stage'] = '3'
surv.loc[surv.loc[:,'clinical_stage'].str.contains('II'),'clinical_stage'] = '2'
surv.loc[surv.loc[:,'clinical_stage'].str.contains('I'),'clinical_stage'] = '1'
surv.loc[surv.loc[:,'clinical_stage'].str.contains('0'),'clinical_stage'] = '0'
surv.loc[ (surv.loc[:,'clinical_stage'] != '4') &
        (surv.loc[:,'clinical_stage'] != '3') &
        (surv.loc[:,'clinical_stage'] != '2') &
        (surv.loc[:,'clinical_stage'] != '1') &
        (surv.loc[:,'clinical_stage'] != '0'),'clinical_stage'] = np.nan
surv.loc[ (surv.loc[:,'age'] == '') ,'age'] = np.nan
#surv.loc[surv.loc[:,'gender']!=np.nan,'gender'] = surv.loc[surv.loc[:,'gender']!=np.nan,'gender'].astype('float64')
surv.loc[:,['gender','age','patho_stage','grade','clinical_stage']] = surv.loc[:,['gender','age','patho_stage','grade','clinical_stage']].astype('float64')
surv.loc[surv.loc[:,'type'] == '[Discrepancy]','type'] = np.nan
surv.loc[surv.loc[:,'type'] == '','type'] = np.nan
surv.to_pickle('update_data/tcga_surv_curate.pkl')
for i in cancer:
    print(i)
    tmp = surv.loc[surv.loc[:,'cancer type abbreviation'] == i,:]
    #for j in [3,4,5,6,7,8]:
    for j in [7]:
        print(pd.unique(tmp.iloc[:,j]))
#'''

#sl calculation
'''ma = pd.read_pickle('update_data/c_max.pkl')
print(ma)
exp = pd.read_pickle('update_data/exp_ceres.pkl')
slope = pd.read_pickle('update_data/c_slope.pkl')
sl = pd.DataFrame(np.nan, columns = ma.index, index = exp.index)
for i in ma.index:
    a = exp.loc[:,i]
    sl.loc[:,i] = -(a - a.quantile(0.25))/slope.loc[i,ma.loc[i,'g1']]
print(sl)
sl.to_pickle('update_data/tcga_sl.pkl')
#'''

#cmax paralog
'''ma = pd.read_pickle('update_data/c_max.pkl')
print(ma)
paralog = pd.read_pickle('update_data/paralog_mapping.pkl')
for i in ma.index:
    print(i)
    if paralog.loc[i,'family'] == paralog.loc[ma.loc[i,'g1'],'family']:
        ma.loc[i,'paralog'] = 1
ma.loc[:,'paralog'].fillna(0, inplace = True)
print(ma.loc[ma.loc[:,'paralog'] == 0,:])
ma.to_pickle('update_data/c_max_paralog.pkl')
#'''

#cancer sl calculation
'''dmap = pd.read_csv('update_data/disease_mapping.txt',index_col = 0, sep = '\t')
surv = pd.read_pickle('update_data/tcga_surv.pkl')
cancer = pd.unique(surv.loc[:,'cancer type abbreviation'])
sl = pd.read_pickle('update_data/tcga_sl.pkl')
dmap = dmap.reindex(cancer.tolist())
dep = pd.read_pickle('update_data/ceres.pkl')
sample = pd.read_pickle('update_data/sample_original.pkl')
sample = sample.reindex(dep.index)
csl = pd.DataFrame(np.nan, index = sl.columns, columns = dmap.index)
dmap.fillna( ' ', inplace = True)
for i in dmap.index:
    idx = sample.index[sample.loc[:,'disease'] == dmap.loc[i,'disease_site']]
    if len(idx) > 0:
        if (dmap.loc[i,'disease_sutype'] != ' ') & (dmap.loc[i,'disease_sub_subtype'] == ' '):
            idx = sample.index[(sample.loc[:,'disease'] == dmap.loc[i,'disease_site']) & (sample.loc[:,'disease_sutype'] == dmap.loc[i,'disease_sutype'])] 
        if (dmap.loc[i,'disease_sutype'] != ' ') & (dmap.loc[i,'disease_sub_subtype'] != ' '):
            idx = sample.index[(sample.loc[:,'disease'] == dmap.loc[i,'disease_site']) & (sample.loc[:,'disease_sutype'] == dmap.loc[i,'disease_sutype']) & (sample.loc[:,'disease_sub_subtype']==dmap.loc[i,'disease_sub_subtype'])]    
        print(i, len(idx))
        csl.loc[:,i] = - sl.loc[idx,:].min()
csl.to_pickle('update_data/csl_min.pkl')
print(csl)
#'''

#dropping the ones only have one cell line
'''csl = pd.read_pickle('update_data/csl_min.pkl')
csl = csl.dropna(how = 'all', axis = 1)
#csl = csl.drop(columns = csl.columns[csl.mean()==0])
print(csl)
print(csl.iloc[0,:])
csl.to_pickle('update_data/csl_min_final.pkl')
#'''

#cox b, p 
'''from lifelines import CoxPHFitter
import warnings
warnings.filterwarnings('ignore')

surv = pd.read_pickle('update_data/tcga_surv_curate.pkl')
tmp = pd.read_pickle('update_data/tcga_exp.pkl')
cancer = list(pd.unique(surv.loc[:,'cancer type abbreviation']))
surv = surv.drop(columns = ['type'])
surv.loc[surv.loc[:,'OS.time'] == '','OS.time'] = np.nan
surv.loc[surv.loc[:,'OS'] == '','OS'] = np.nan
feature = ['gender','age','patho_stage','clinical_stage','grade']
surv = surv.reindex(columns = feature + ['OS.time','OS','cancer type abbreviation'])


def Calcox(start):

    print(start)
    increment = 5
    end = start+increment
    if end > len(tmp.index):
        end = len(tmp.index)
    exp = tmp.iloc[start:end,:]
    cox_b = pd.DataFrame(np.nan, index = exp.index, columns = cancer)
    cox_p = pd.DataFrame(np.nan, index = exp.index, columns = cancer)
    #for i in cancer:
    for i in ['GBM']:
        cp = surv.loc[surv.loc[:,'cancer type abbreviation'] == i,:]
        cp = cp.drop(columns = ['cancer type abbreviation'])
        for j in feature:
            tmp_cp = cp.loc[:,j].dropna(how = 'any')
            strat = pd.unique(tmp_cp)
            if len(strat) <= 1:
                cp = cp.drop(columns = [j])
        cp = cp.dropna( how ='any')
        cph = CoxPHFitter()
        for j in exp.index:
            cp.loc[:,'exp'] = exp.loc[j,cp.index]
            try:
                cph.fit(cp, duration_col = 'OS.time', event_col = 'OS')
                x = cph.params_
                print(x)
                cox_b.loc[j,i] = x.loc['exp']
                y = x.index.get_loc('exp')
                y = cph._compute_p_values()[y]
                cox_p.loc[j,i] = y
            except:
                cox_b.loc[j,i] = np.nan
                cox_p.loc[j,i] = np.nan
    return cox_b, cox_p

import multiprocessing as mp
import os
if __name__ == '__main__':
    pool = mp.Pool(processes=20)
    start = list(range(0,len(tmp.index),5))
    res = pool.map(Calcox, start)
    coxb = []
    coxp = []
    for b, p in res:
        coxb.append(b)
        coxp.append(p)
    coxb = pd.concat(coxb, axis = 0)
    coxp = pd.concat(coxp, axis = 0)
    print(coxb)
    print(coxp)
    #coxb.to_pickle('update_data/cox_covariate_b.pkl')
    #coxp.to_pickle('update_data/cox_covariate_p.pkl')
#'''

#deomstration
'''sample = pd.read_pickle('update_data/sample_original.pkl')
dep = pd.read_pickle('update_data/ceres.pkl')
exp = pd.read_pickle('update_data/exp_ceres.pkl')
g1 = 'NAMPT'
g2 = 'CALD1'
out = pd.concat([dep.loc[:,g1],exp.loc[:,g2]],axis = 1)
sample.reindex(dep.index)
out.loc[:,'size'] = 0
out.loc[:,'type'] = np.nan
out.loc[sample.loc[:,'disease_sutype'] == 'glioma',['size','type']] = [5,'LGG']
out.loc[sample.loc[:,'disease_sutype'] == 'AML',['size','type']] = [5,'LAML']
out.loc[:,'type'].fillna('',inplace = True)
out.loc[:,'size'].fillna(1,inplace = True)
out = out.dropna(how = 'any')
print(out)
out.to_csv('working_data/cscore_demonstration.csv')
exp = pd.read_pickle('update_data/tcga_exp.pkl')
surv = pd.read_pickle('update_data/tcga_surv_curate.pkl')
surv = surv.loc[ (surv.loc[:,'cancer type abbreviation'] == 'LGG') |
        (surv.loc[:,'cancer type abbreviation'] == 'LAML'), :]
for i in ['LGG', 'LAML']:
    cp = surv.loc[surv.loc[:,'cancer type abbreviation'] == i,:]
    tmp = exp.loc[g2,cp.index]
    surv.loc[ tmp.index[ tmp > tmp.quantile(0.75) ], 'perc'] = 'exp_high'
    surv.loc[ tmp.index[ tmp < tmp.quantile(0.25) ], 'perc'] = 'exp_low'
    surv.loc[ tmp.index[ (tmp >= tmp.quantile(0.25)) & (tmp < tmp.quantile(0.5)) ], 'perc'] = 'exp_mid_l'
    surv.loc[ tmp.index[ (tmp >= tmp.quantile(0.5)) & (tmp <= tmp.quantile(0.75)) ], 'perc'] = 'exp_mid_h'
surv = surv.rename(columns = {'cancer type abbreviation':'disease'})
print(surv)
surv.to_csv('working_data/surv_demonstration.csv')
#'''

#roc p-value adjustment cox covariate
'''from sklearn.metrics import roc_curve, auc
import matplotlib.backends.backend_pdf
from matplotlib import cm
import statsmodels.stats.multitest as stat
import warnings
warnings.filterwarnings('ignore')


pdf = matplotlib.backends.backend_pdf.PdfPages('6_7_roc_p_adj_covariate.pdf')
rank = pd.read_pickle('update_data/cox_covariate_p.pkl')
csl = pd.read_pickle('update_data/csl_min_final.pkl')
g2 = pd.read_pickle('update_data/c_max.pkl')
csl = csl.reindex(rank.index)
cox = pd.read_pickle('update_data/cox_covariate_b.pkl')
cox = cox.dropna(how = 'any')
rank = rank.reindex(index = cox.index,columns = csl.columns)
fdr = pd.DataFrame( np.nan, index = rank.index, columns = rank.columns)
for i in fdr.columns:
    tmp = rank.loc[:,i].dropna()
    #fdr.loc[:,i] = stat.multipletests(fdr.loc[:,i].values.tolist(), method = 'fdr_bh')
    reject, correct, _ , _ = stat.multipletests(tmp, method = 'fdr_bh')
    #reject, correct, _ , _ = stat.multipletests(tmp)
    fdr.loc[tmp.index,i] = correct
rank = ((fdr<0.2) & (cox > 0)).astype('float64')

cm_subsection = np.linspace(0,1,10)
colors = [cm.hot(i) for i in cm_subsection]

result = pd.DataFrame( np.nan, index = ['no',0.15,0.2,0.25,0.3,0.35,0.4], columns = csl.columns)
result.loc[:,'all'] = np.nan
for i in csl.columns:
    fig = plt.figure()
    ax = fig.add_subplot(111)
    cnt = 0
    expsl = pd.concat([csl.loc[:,i], rank.loc[:,i]], axis = 1)
    expsl.columns = ['sl','km']
    expsl = expsl.dropna(how = 'any')
    expsl = expsl.astype('float64')
    y_t = expsl.loc[:,'km']
    x_t = expsl.loc[:,'sl']
    fpr, tpr, _ = roc_curve(y_t, x_t)
    roc_aur = auc(fpr, tpr)
    plt.text( 0.9, 0.5, 'no: %.2f' %roc_aur, transform = ax.transAxes)
    if True:
        plt.plot( fpr, tpr, color = colors[cnt], lw = 2)
        cnt += 1
    for j in [0.15,0.2,0.25,0.3,0.35,0.4]:
        expsl = pd.concat([csl.loc[:,i], rank.loc[:,i], g2.loc[:,'max']], axis = 1)
        expsl.columns = ['sl','km','c']
        expsl = expsl.loc[expsl.loc[:,'c']>j,:]
        expsl = expsl.dropna(how = 'any')
        expsl = expsl.astype('float64')
        y_t = expsl.loc[:,'km']
        x_t = expsl.loc[:,'sl']
        fpr, tpr, _ = roc_curve(y_t, x_t)
        roc_aur = auc(fpr, tpr)
        plt.text( 0.9, j, '%.2f: %.2f' %(j,roc_aur), transform = ax.transAxes)
        if True:
            plt.plot( fpr, tpr, color = colors[cnt], lw = 2)
            cnt += 1
    plt.plot( [0,1],[0,1],color = 'navy',lw = 2, linestyle = '--')
    plt.xlabel('False Positive Rate')
    plt.ylabel('True Positive Rate')
    plt.title(i)
    pdf.savefig(fig)
    plt.close()
pdf.close()
#'''

#roc to R covariate
'''import statsmodels.stats.multitest as stat
rank = pd.read_pickle('update_data/cox_covariate_p.pkl')
csl = pd.read_pickle('update_data/csl_min_final.pkl')
g2 = pd.read_pickle('update_data/c_max.pkl')
cox = pd.read_pickle('update_data/cox_covariate_b.pkl')
cox = cox.dropna(how = 'any')
rank = rank.reindex(cox.index,csl.columns)
csl = csl.reindex(rank.index)

fdr = pd.DataFrame( np.nan, index = rank.index, columns = rank.columns)
for i in fdr.columns:
    tmp = rank.loc[:,i].dropna()
    #fdr.loc[:,i] = stat.multipletests(fdr.loc[:,i].values.tolist(), method = 'fdr_bh')
    reject, correct, _ , _ = stat.multipletests(tmp, method = 'fdr_bh')
    #reject, correct, _ , _ = stat.multipletests(tmp)
    fdr.loc[tmp.index,i] = correct
rank = ((fdr<0.2) & (cox > 0)).astype('float64')

g2 = g2.reindex(rank.index).loc[:,['max']]
g2.columns = ['c']
g2 = g2.dropna(how = 'any')
rank = rank.reindex(g2.index)
csl = csl.reindex(g2.index)
rank = rank.dropna(how = 'all', axis = 1)
rank.to_csv('working_data/logrank_adj.csv')
g2.to_csv('working_data/g2_c.csv')
csl.to_csv('working_data/csl_min_final.csv')
#'''

'''surv = pd.read_pickle('update_data/tcga_surv_curate.pkl')
surv = surv.loc[surv.loc[:,'cancer type abbreviation'] == 'OV',:]
feature = ['gender','age','patho_stage','clinical_stage','grade']
surv = surv.reindex(columns = feature).dropna(how = 'all', axis = 1)
tmp = surv.copy()
surv = pd.read_pickle('update_data/tcga_surv_curate_old.pkl')
surv = surv.loc[surv.loc[:,'cancer type abbreviation'] == 'OV',:]
feature = ['gender','age','patho_stage','clinical_stage','grade']
surv = surv.reindex(columns = feature).dropna(how = 'all', axis = 1)
df_diff = pd.concat([surv, tmp]).drop_duplicates(keep = False)
print(df_diff)
#'''

#roc p-value adjustment paralog
#mann whitney U
'''from sklearn.metrics import roc_curve, auc
import matplotlib.backends.backend_pdf
from matplotlib import cm
import statsmodels.stats.multitest as stat
import scipy.stats as stat_2

pdf = matplotlib.backends.backend_pdf.PdfPages('6_6_roc_p_adj_covariate.pdf')
rank = pd.read_pickle('update_data/cox_covariate_p.pkl')
csl = pd.read_pickle('update_data/csl_min_final.pkl')
g2 = pd.read_pickle('update_data/c_max.pkl')
csl = csl.reindex(rank.index)
g2 = g2.reindex(rank.index)
cox = pd.read_pickle('update_data/cox_covariate_b.pkl')
cox = cox.dropna(how = 'any')
rank = rank.reindex(cox.index,csl.columns)

fdr = pd.DataFrame( np.nan, index = rank.index, columns = rank.columns)
for i in fdr.columns:
    tmp = rank.loc[:,i].dropna()
    #fdr.loc[:,i] = stat.multipletests(fdr.loc[:,i].values.tolist(), method = 'fdr_bh')
    reject, correct, _ , _ = stat.multipletests(tmp, method = 'fdr_bh')
    #reject, correct, _ , _ = stat.multipletests(tmp)
    fdr.loc[tmp.index,i] = correct
rank = ((fdr<0.2) & (cox > 0)).astype('float64')
cm_subsection = np.linspace(0,1,10)
colors = [cm.hot(i) for i in cm_subsection]

import warnings
warnings.filterwarnings('ignore')

result_p = pd.DataFrame( np.nan, index = ['no',0.15,0.2,0.25,0.3,0.35,0.4], columns = csl.columns)
result_u = pd.DataFrame( np.nan, index = ['no',0.15,0.2,0.25,0.3,0.35,0.4], columns = csl.columns)
for i in ['GBM']:
    fig = plt.figure()
    ax = fig.add_subplot(111)
    cnt = 0
    expsl = pd.concat([csl.loc[:,i], rank.loc[:,i], g2.loc[:,'max']], axis = 1)
    expsl.columns = ['sl','km','c']
    expsl = expsl.dropna(how = 'any')
    expsl = expsl.astype('float64')
    y_t = expsl.loc[:,'km']
    x_t = expsl.loc[:,'sl']
    fpr, tpr, _ = roc_curve(y_t, x_t)
    roc_aur = auc(fpr, tpr)
    result_u.loc['no',i] = roc_aur
    _, result_p.loc['no',i] = stat_2.mannwhitneyu( expsl.loc[expsl.loc[:,'km'] == 1,'sl'], expsl.loc[expsl.loc[:,'km'] == 0,'sl'])
    plt.text( 0.9, 0.5, 'no: %.2f' %roc_aur, transform = ax.transAxes)
    if True:
        plt.plot( fpr, tpr, color = colors[cnt], lw = 2)
        cnt += 1
    for j in [0.15,0.2,0.25,0.3,0.35,0.4]:
        expsl = pd.concat([csl.loc[:,i], rank.loc[:,i], g2.loc[:,'max']], axis = 1)
        expsl.columns = ['sl','km','c']
        expsl = expsl.loc[expsl.loc[:,'c']>j,:]
        expsl = expsl.dropna(how = 'any')
        expsl = expsl.astype('float64')
        y_t = expsl.loc[:,'km']
        x_t = expsl.loc[:,'sl']
        fpr, tpr, _ = roc_curve(y_t, x_t)
        roc_aur = auc(fpr, tpr)
        plt.text( 0.9, j, '%.2f: %.2f' %(j,roc_aur), transform = ax.transAxes)
        _, result_p.loc[j,i] = stat_2.mannwhitneyu( expsl.loc[expsl.loc[:,'km'] == 1,'sl'], expsl.loc[expsl.loc[:,'km'] == 0,'sl'])
        result_u.loc[j,i] = roc_aur
        if True:
            plt.plot( fpr, tpr, color = colors[cnt], lw = 2)
            cnt += 1
    plt.plot( [0,1],[0,1],color = 'navy',lw = 2, linestyle = '--')
    plt.xlabel('False Positive Rate')
    plt.ylabel('True Positive Rate')
    plt.title(i)
    pdf.savefig(fig)
    plt.close()
result_u = result_u[result_p<0.2]
print(result_u.T)
pdf.close()
#'''

#spearman calculation
'''from scipy import stats
tmp = pd.read_pickle('update_data/tcga_exp.pkl')
surv = pd.read_pickle('update_data/tcga_surv_curate.pkl')
tmp = tmp.T
csl = pd.read_pickle('update_data/csl_min_final.pkl')
todo = ['patho_stage','clinical_stage','grade']
todo = 'clinical_stage'
def CalCausality(start):
    increment = 5
    end = start+increment
    if end > len(tmp.columns):
        end = len(tmp.columns)
    exp = tmp.iloc[:,start:end]
    cor = pd.DataFrame( np.nan, index = exp.columns, columns = csl.columns)
    cor_p = pd.DataFrame( np.nan, index = exp.columns, columns = csl.columns)
    for i in cor.columns:
        cp = surv.loc[surv.loc[:,'cancer type abbreviation'] == i,:]
        exp_t = exp.loc[surv.loc[:,'cancer type abbreviation'] == i,:]
        cp = pd.concat([cp.loc[:,[todo]],exp_t], axis = 1)
        for j in cor.index:
            x = cp.loc[:,[todo,j]].dropna(how = 'any')
            cor.loc[j,i], cor_p.loc[j,i] = stats.spearmanr(x.loc[:,todo],x.loc[:,j])
    return cor, cor_p
import multiprocessing as mp
import os
if __name__ == '__main__':
    pool = mp.Pool(processes=8)
    start = list(range(0,len(tmp.columns),5))
    print(len(tmp.columns))
    res = pool.map(CalCausality, start)
    cor = []
    cor_p = []
    for i in res:
        cor.append(i[0])
        cor_p.append(i[1])
    cor = pd.concat(cor)
    cor_p = pd.concat(cor_p)

    print(cor)
    print(cor_p)
    cor.to_pickle('update_data/tcga_'+todo+'_cor.pkl')
    cor_p.to_pickle('update_data/tcga_'+todo+'_cor_p.pkl')
#'''

#cor with staging roc evaluation
'''cor_b = load_obj( 'update_data/exp_stage_cor.pkl') 
cor_p = load_obj( 'update_data/exp_stage_cor_p.pkl') 
print(cor_b)
from sklearn.metrics import roc_curve, auc
import matplotlib.backends.backend_pdf
from matplotlib import cm
import statsmodels.stats.multitest as stat

pdf = matplotlib.backends.backend_pdf.PdfPages('6_8_cor_stage.pdf')
feature = ['patho_stage', 'clinical_stage', 'grade']
for k in feature:
    #print(rank)
    rank = cor_p[k]
    cox = cor_b[k]
    csl = pd.read_pickle('update_data/csl_min_final.pkl')
    g2 = pd.read_pickle('update_data/c_max_paralog.pkl')
    csl = csl.reindex(rank.index)

    fdr = pd.DataFrame( np.nan, index = rank.index, columns = rank.columns)
    for i in fdr.columns:
        tmp = rank.loc[:,i].dropna()
        if len(tmp) == 0:
            continue
        #fdr.loc[:,i] = stat.multipletests(fdr.loc[:,i].values.tolist(), method = 'fdr_bh')
        reject, correct, _ , _ = stat.multipletests(tmp, method = 'fdr_bh')
        #reject, correct, _ , _ = stat.multipletests(tmp)
        fdr.loc[tmp.index,i] = correct
    rank = ((fdr<0.2) & (cox > 0)).astype('float64')

    cm_subsection = np.linspace(0,1,10)
    colors = [cm.hot(i) for i in cm_subsection]

    result = pd.DataFrame( np.nan, index = ['no',0.15,0.2,0.25,0.3,0.35,0.4], columns = csl.columns)
    result.loc[:,'all'] = np.nan
    for i in csl.columns:
        fig = plt.figure()
        ax = fig.add_subplot(111)
        cnt = 0
        expsl = pd.concat([csl.loc[:,i], rank.loc[:,i]], axis = 1)
        expsl.columns = ['sl','km']
        expsl = expsl.dropna(how = 'any')
        expsl = expsl.astype('float64')
        y_t = expsl.loc[:,'km']
        x_t = expsl.loc[:,'sl']
        fpr, tpr, _ = roc_curve(y_t, x_t)
        roc_aur = auc(fpr, tpr)
        plt.text( 0.9, 0.5, 'no: %.2f' %roc_aur, transform = ax.transAxes)
        if True:
            plt.plot( fpr, tpr, color = colors[cnt], lw = 2)
            cnt += 1
        for j in [0.15,0.2,0.25,0.3,0.35,0.4]:
            expsl = pd.concat([csl.loc[:,i], rank.loc[:,i], g2.loc[:,'max']], axis = 1)
            expsl.columns = ['sl','km','c']
            expsl = expsl.loc[expsl.loc[:,'c']>j,:]
            expsl = expsl.dropna(how = 'any')
            expsl = expsl.astype('float64')
            y_t = expsl.loc[:,'km']
            x_t = expsl.loc[:,'sl']
            fpr, tpr, _ = roc_curve(y_t, x_t)
            roc_aur = auc(fpr, tpr)
            plt.text( 0.9, j, '%.2f: %.2f' %(j,roc_aur), transform = ax.transAxes)
            if True:
                plt.plot( fpr, tpr, color = colors[cnt], lw = 2)
                cnt += 1
        plt.plot( [0,1],[0,1],color = 'navy',lw = 2, linestyle = '--')
        plt.xlabel('False Positive Rate')
        plt.ylabel('True Positive Rate')
        plt.title(i+'_'+k)
        pdf.savefig(fig)
        plt.close()
pdf.close()
#'''

'''cor_b = load_obj( 'update_data/exp_stage_cor.pkl') 
cor_p = load_obj( 'update_data/exp_stage_cor_p.pkl') 
#print(cor_b)
from sklearn.metrics import roc_curve, auc
import matplotlib.backends.backend_pdf
from matplotlib import cm
import statsmodels.stats.multitest as stat

pdf = matplotlib.backends.backend_pdf.PdfPages('6_8_cor_stage_2.pdf')
feature = ['patho_stage', 'clinical_stage','grade']
for k in feature:
    #print(rank)
    rank = cor_p[k]
    cox = cor_b[k]
    csl = pd.read_pickle('update_data/csl_min_final.pkl')
    g2 = pd.read_pickle('update_data/c_max_paralog.pkl')
    csl = csl.reindex(rank.index)

    fdr = pd.DataFrame( np.nan, index = rank.index, columns = rank.columns)
    for i in fdr.columns:
        tmp = rank.loc[:,i].dropna()
        if len(tmp) == 0:
            continue
        #fdr.loc[:,i] = stat.multipletests(fdr.loc[:,i].values.tolist(), method = 'fdr_bh')
        reject, correct, _ , _ = stat.multipletests(tmp, method = 'fdr_bh')
        #reject, correct, _ , _ = stat.multipletests(tmp)
        fdr.loc[tmp.index,i] = correct
    rank = ((fdr<0.2) & (cox > 0)).astype('float64')

    cm_subsection = np.linspace(0,1,10)
    colors = [cm.hot(i) for i in cm_subsection]

    result = pd.DataFrame( np.nan, index = ['no',0.15,0.2,0.25,0.3,0.35,0.4], columns = csl.columns)
    result.loc[:,'all'] = np.nan
    for i in ['PAAD','OV']:
        fig = plt.figure()
        ax = fig.add_subplot(111)
        cnt = 0
        expsl = pd.concat([csl.loc[:,i], rank.loc[:,i], g2.loc[:,'max']], axis = 1)
        expsl.columns = ['sl','km','c']
        expsl = expsl.dropna(how = 'any')
        expsl = expsl.astype('float64')
        expsl.to_csv('working_data/roc'+'_'+i+'_'+k+'.csv')
        y_t = expsl.loc[:,'km']
        x_t = expsl.loc[:,'sl']
        fpr, tpr, _ = roc_curve(y_t, x_t)
        roc_aur = auc(fpr, tpr)
        plt.text( 0.9, 0.5, 'no: %.2f' %roc_aur, transform = ax.transAxes)
        if True:
            plt.plot( fpr, tpr, color = colors[cnt], lw = 2)
            cnt += 1
        for j in [0.15,0.2,0.25,0.3,0.35,0.4]:
            expsl = pd.concat([csl.loc[:,i], rank.loc[:,i], g2.loc[:,'max']], axis = 1)
            expsl.columns = ['sl','km','c']
            expsl = expsl.loc[expsl.loc[:,'c']>j,:]
            expsl = expsl.dropna(how = 'any')
            expsl = expsl.astype('float64')
            y_t = expsl.loc[:,'km']
            x_t = expsl.loc[:,'sl']
            fpr, tpr, _ = roc_curve(y_t, x_t)
            roc_aur = auc(fpr, tpr)
            plt.text( 0.9, j, '%.2f: %.2f' %(j,roc_aur), transform = ax.transAxes)
            if True:
                plt.plot( fpr, tpr, color = colors[cnt], lw = 2)
                cnt += 1
        plt.plot( [0,1],[0,1],color = 'navy',lw = 2, linestyle = '--')
        plt.xlabel('False Positive Rate')
        plt.ylabel('True Positive Rate')
        plt.title(i+'_'+k)
        pdf.savefig(fig)
        plt.close()
pdf.close()
#'''

#mann whitney U
'''cor_b = load_obj( 'update_data/exp_stage_cor.pkl') 
cor_p = load_obj( 'update_data/exp_stage_cor_p.pkl') 
import statsmodels.stats.multitest as stat
import scipy.stats as stat_2
from sklearn.metrics import roc_curve, auc

import warnings
warnings.filterwarnings('ignore')
feature = ['patho_stage', 'clinical_stage', 'grade']
for k in feature:
    print(k)
    rank = cor_p[k]
    cox = cor_b[k]
    csl = pd.read_pickle('update_data/csl_min_final.pkl')
    g2 = pd.read_pickle('update_data/c_max_paralog.pkl')
    csl = csl.reindex(rank.index)

    fdr = pd.DataFrame( np.nan, index = rank.index, columns = rank.columns)
    for i in fdr.columns:
        tmp = rank.loc[:,i].dropna()
        if len(tmp) == 0:
            continue
        #fdr.loc[:,i] = stat.multipletests(fdr.loc[:,i].values.tolist(), method = 'fdr_bh')
        reject, correct, _ , _ = stat.multipletests(tmp, method = 'fdr_bh')
        #reject, correct, _ , _ = stat.multipletests(tmp)
        fdr.loc[tmp.index,i] = correct
    rank = ((fdr<0.2) & (cox > 0)).astype('float64')

    result_u = pd.DataFrame( np.nan, index = ['no',0.15,0.2,0.25,0.3,0.35,0.4], columns = csl.columns)
    result_p = pd.DataFrame( np.nan, index = ['no',0.15,0.2,0.25,0.3,0.35,0.4], columns = csl.columns)
    for i in csl.columns:
    #for i in ['PAAD']:
        expsl = pd.concat([csl.loc[:,i], rank.loc[:,i]], axis = 1)
        expsl.columns = ['sl','km']
        expsl = expsl.dropna(how = 'any')
        expsl = expsl.astype('float64')
        _, result_p.loc['no',i] = stat_2.mannwhitneyu( expsl.loc[expsl.loc[:,'km'] == 1,'sl'], expsl.loc[expsl.loc[:,'km'] == 0,'sl'])
        y_t = expsl.loc[:,'km']
        x_t = expsl.loc[:,'sl']
        fpr, tpr, _ = roc_curve(y_t, x_t)
        result_u.loc['no',i] = auc(fpr, tpr)
        for j in [0.15,0.2,0.25,0.3,0.35,0.4]:
            expsl = pd.concat([csl.loc[:,i], rank.loc[:,i], g2.loc[:,'max']], axis = 1)
            expsl.columns = ['sl','km','c']
            expsl = expsl.loc[expsl.loc[:,'c']>j,:]
            expsl = expsl.dropna(how = 'any')
            expsl = expsl.astype('float64')
            y_t = expsl.loc[:,'km']
            x_t = expsl.loc[:,'sl']
            fpr, tpr, _ = roc_curve(y_t, x_t)
            _, result_p.loc[j,i] = stat_2.mannwhitneyu( expsl.loc[expsl.loc[:,'km'] == 1,'sl'], expsl.loc[expsl.loc[:,'km'] == 0,'sl'])
            result_u.loc[j,i] = auc(fpr, tpr)
    #print(k)
    #result_u = result_u[result_p<0.05]
    result_p = result_p[(result_p<0.05)&(result_u>0.5)]
    print(result_p.dropna(how='all',axis =1))
    result_p = result_p.dropna(how='all',axis =1)
    result_p.to_csv(k+'_pvalue.csv')
    #print(result_test)
#'''


