.libPaths( c('/tmp2/b04401068/lib/R/',.libPaths()))
library(RColorBrewer)
library(ggplot2)

#6-survival
#survival demonstration
if(TRUE)
{
	library(survminer)
	library(survival)
	pdf("6_2_demonstration_6.pdf", width = 8, height = 7, onefile = TRUE)
	mat <- read.csv( 'working_data/cscore_demonstration.csv', row.names = 1);
	print(head(mat))
	mat$type <- factor(mat$type)
	graph <- ggplot(mat, aes(x=NAMPT , y=CALD1))+ 
		geom_point( aes(fill = type, size = size), color = 'black', pch = 21, alpha = 0.5)+
		scale_size_continuous(range = c(2,5))+
		scale_fill_manual(values = c('grey60','red','dodgerblue'))+
		theme_classic()+
		theme(panel.border = element_blank(),
		      axis.line = element_line(),
		      plot.title=element_text(size=20, 
					    face="bold", 
					    #family="American Typewriter",
					    #color="tomato",
					    hjust=0.5,
					    lineheight=1.2),  # title
		    plot.subtitle=element_text(size=15, 
					       #family="American Typewriter",
					       face="bold",
					       hjust=0.5),  # subtitle
		    plot.caption=element_text(size=15),  # caption
		    axis.title.x=element_text(
					      #vjust=10,  
					      size=15),  # X axis title
		    axis.title.y=element_text(size=15),  # Y axis title
		    axis.text.x=element_text(size=15, 
					     #angle = 30,
					     #vjust=.5
					     ),  # X axis text
		    axis.text.y=element_text(size=15),
		    axis.ticks.length = unit(.25, 'cm'))+
		coord_capped_cart(left = 'both', bottom = 'both')
	print(graph)
	mat <- read.csv( 'working_data/surv_demonstration.csv', row.names = 1);
	mat$disease <- factor(mat$disease)
	for( i in levels(mat$disease))
	{
		tmp <- mat[ ((mat$perc == 'exp_low')|(mat$perc == 'exp_high')) & (mat$disease == i),]
		#tmp <- mat[ (mat$disease == i),]
		tmp$perc = factor(tmp$perc)
		#print(tmp)
		fit <- survfit(Surv(OS.time,OS)~perc, data = tmp)
		graph <- ggsurvplot(fit, 
			   data = tmp,
			   pval = TRUE,
		legend.title = i)
		print(graph)
	}
	dev.off()
}

#6-7 ROC
if(FALSE)
{
	library(pROC)
	x = colorRampPalette(rev(brewer.pal(n = 7, name = "Reds")))(10)
	c <- read.csv('working_data/g2_c.csv', row.names = 1)
	rank <- read.csv('working_data/logrank_adj.csv', row.names = 1)
	sl <- read.csv('working_data/csl_min_final.csv', row.names = 1)
	pdf("6-7_SL_ROC_adg.pdf", width = 8, height = 7, onefile = TRUE)
	for( i in colnames(rank))
	{
		print(i)
		tmp <- cbind( rank[,i], sl[,i], c[,'c'])
		colnames(tmp) <- c('rank','sl','c')
		tmp <- as.data.frame(tmp)
		try(
		    plot.roc(tmp$rank,tmp$sl,col = x[7], quiet = TRUE, percent = TRUE, ci=TRUE, print.auc = TRUE, main = i, print.auc.y = 10, direction = '<')
		    , silent = TRUE)
		cnt <- 6
		for( j in c(0.15,0.2,0.25,0.3,0.35,0.4) )
		{
			tmp <- tmp[tmp[,'c']>j,]
			try(
				plot.roc( tmp$rank,tmp$sl, col = x[cnt],percent = TRUE, quiet = TRUE, ci=TRUE, print.auc = TRUE, print.auc.y = (j * 100), add=TRUE, direction = '<')
				,silent = TRUE)

			cnt <- cnt - 1
		}
	}
	dev.off()
}

#6-7 spearman correlation
if(FALSE)
{
	library(pROC)
	x = colorRampPalette(rev(brewer.pal(n = 7, name = "Reds")))(10)
	pdf("6-7_paadstage.pdf", width = 8, height = 7, onefile = TRUE)
	#pdf("6-7_paadstage.pdf", onefile = TRUE)
	tmp <- read.csv('PAAD_patho_stage.csv',row.names = 1)
	print(head(tmp))
	colnames(tmp) <- c('c','sl','rank')
	tmp <- as.data.frame(tmp)
	i<-'PAAD'
	try(
	    plot.roc(tmp$rank,tmp$sl,col = x[7], quiet = TRUE, percent = TRUE, ci=TRUE, print.auc = TRUE, main = i, print.auc.y = 10, direction = '<')
	    , silent = TRUE)
	cnt <- 6
	for( j in c(0.15,0.2,0.25,0.3,0.35,0.4) )
	{
		tmp <- tmp[tmp[,'c']>j,]
		try(
			plot.roc( tmp$rank,tmp$sl, col = x[cnt],percent = TRUE, quiet = TRUE, ci=TRUE, print.auc = TRUE, print.auc.y = (j * 100), add=TRUE, direction = '<')
			,silent = TRUE)

		cnt <- cnt - 1
	}
	dev.off()
}
