#!/usr/bin/perl

use strict;

my $genelist = $ARGV[0];
my $pgroup_file = $ARGV[1];


my %pgroup;

open( PGROUP, $pgroup_file ) or die "Can't open $pgroup_file";
while( <PGROUP> ) {
	$_ =~ s/^\s+|\s+$//g;

	my @line = split "\t", $_;

	my @genes = split ",", $line[1];

	foreach my $g ( @genes ) {
		$pgroup{$g} = $line[0];
	}
}
close PGROUP;

open( GL, $genelist )or die "Can't open $genelist";
while( <GL> ) {
	$_=~ s/^\s+|\s+$//g;

	my @line = split "\t", $_;

	my $g1 = $line[0];
	my $g2 = $line[1];

	my ( $g1_id, $g2_id ) = ("NA", "NA");
	if ( $pgroup{$g1} == $pgroup{$g2} ) {
		$g1_id = "P";
		$g2_id = "P";
	} else {
		if ($pgroup{$g1} == 0 ) {
			$g1_id = "S";
		}
		if ($pgroup{$g2} == 0 ) {
			$g2_id = "S";
		}
		if ($pgroup{$g1} > 0 ) {
			$g1_id = "D";
		}
		if ($pgroup{$g2} > 0 ) {
			$g2_id = "D";
		}
	}
	print $g1."\t".$g2."\t".$g1_id."\t".$g2_id."\n";
}
close GL;

	
	

